# f[^֘A
 # 쑺f[^ID
  HoshinoID <- c(7,12,15,31,37,52,59,62,72,73,76:78,83,86,87,93,96,100,102,104,107,
                 111,116,120,126,127,131,133,135)

 # \TDP
  # Estimated Parameters for Richards iT͂ŗpj
  Y.sec5 <- matrix(c(
  1.205731, -4.475871, 0.672727,
  0.924838, -4.509502, 0.661995,
  1.571397, -4.746084, 0.658560,
  2.326158, -5.121585, 0.681071,
  0.864656, -4.553767, 0.608244,
  0.996801, -4.460639, 0.829816,
  1.853015, -4.141503, 1.068861,
  2.127897, -4.139968, 1.136689,
  2.894038, -4.294159, 1.184056,
  2.505835, -4.064964, 1.262950,
  2.980130, -4.368402, 1.204812,
  2.172049, -3.997503, 1.242416,
  3.211132, -4.422698, 1.138928,
  8.604063, -7.902800, 0.806151,
  2.915821, -3.798438, 1.537273,
  1.677026, -4.847315, 0.807966,
  1.521722, -4.874978, 0.718842,
  1.030001, -4.379237, 0.759963,
  0.523113, -3.831800, 0.994060,
  1.432905, -4.391414, 0.893144,
  4.697766, -6.145969, 0.809549,
  1.067457, -4.670533, 0.773574,
  1.431934, -4.280478, 0.901158,
  2.590012, -5.319104, 0.749851,
  1.143341, -4.247414, 0.888942,
  1.307521, -4.347252, 0.968029,
  2.716477, -5.545586, 0.797387,
  0.781965, -2.832018, 1.288182,
  5.209063, -6.222249, 0.863150,
  0.830122, -4.301792, 0.842584), byrow=T, ncol=3)



# 
# ֐iXNvgPDPj----------------------------------------------------
 GC.Hos4.func <- function(a,b,c,t){(t^c)/(b+(t^c/a))}     # Hossfeld-4
 GC.Gom.func <- function(a,b,c,t){a*exp(-b*exp(-c*t))}    # Gompertz
 GC.Log.func <- function(a,b,c,t){a/(1+c*exp(-b*t))}      # Logistic
 GC.Mon.func <- function(a,b,c,t){a*(1-b*exp(-c*t))}      # Monomolecular
 GC.Ber.func <- function(a,b,t){a*(1-exp(-b*t))^3}        # Bertlanffy
 GC.CR.func <- function(a,b,c,t){a*(1-exp(-b*t))^c}       # Chapman-Richards
 GC.Lev1.func <- function(a,b,c,d,t){a*(t^d/(b+t^d))^c}   # Levacovic-1
 GC.Lev3.func <- function(a,b,c,t){a*(t^2/(b+t^2))^c}     # Levacovic-3
 GC.Kor.func <- function(a,b,c,t){a*exp(-b*t^(-c))}       # Korf
 GC.Wei.func <- function(a,b,c,t){a*(1-exp(-b*t^(c)))}    # Weibull
 GC.Yos1.func <- function(a,b,c,d,t){(a*t^d)/(b+t^d)+c}   # Yoshida-1
 GC.Slo.func <- function(a,b,c,d,t){a*exp(-b*exp(-c*t^(d)))}  # Sloboda
 GC.Full.func <- function(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,t)
                  {a1*((t^a4)/(a2+a3*t^a4))^a5+a6*(1-a7*exp(-a8*t))^a9 +
                    a10*exp(-a11*t^a12)+a13*exp(-a14*exp(-a15*t^(-a16)))
                  }
  
 # p[^w
  GC.expHos4.func <- function(a,b,c,t){(t^exp(c))/(exp(b)+(t^exp(c)/exp(a)))}
  GC.expGom.func <- function(a,b,c,t){exp(a)*exp(-exp(b)*exp(-exp(c)*t))}
  GC.expLog.func <- function(a,b,c,t){exp(a)/(1+exp(c)*exp(-exp(b)*t))}
  GC.expMon.func <- function(a,b,c,t){exp(a)*(1-exp(b)*exp(-exp(c)*t))}
  GC.expBer.func <- function(a,b,t){exp(a)*(1-exp(-exp(b)*t))^3}
  GC.expCR.func <- function(a,b,c,t){exp(a)*(1-exp(-exp(b)*t))^exp(c)}
  GC.expLev1.func <- function(a,b,c,d,t){exp(a)*(t^exp(d)/(exp(b)+t^exp(d)))^exp(c)}
  GC.expLev3.func <- function(a,b,c,t){exp(a)*(t^2/(exp(b)+t^2))^exp(c)}
  GC.expKor.func <- function(a,b,c,t){exp(a)*exp(-exp(b)*t^(-exp(c)))}
  GC.expWei.func <- function(a,b,c,t){exp(a)*(1-exp(-exp(b)*t^exp(c)))}
  GC.expYos1.func <- function(a,b,c,d,t){(exp(a)*t^exp(d))/(exp(b)+t^exp(d))+exp(c)}
  GC.expSlo.func <- function(a,b,c,d,t){exp(a)*exp(-exp(b)*exp(-exp(c)*t^(exp(d))))}
  GC.expFull.func <- function(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16,t)
                    {exp(a1)*((t^exp(a4))/(exp(a2)+exp(a3)*t^exp(a4)))^exp(a5)+
                      exp(a6)*(1-exp(a7)*exp(-exp(a8)*t))^exp(a9)+
                      exp(a10)*exp(-exp(a11)*t^exp(a12))+exp(a13)*exp(-exp(a14)*exp(-exp(a15)*t^(-exp(a16))))
                     }
  
 # ֐ɂ関mp[^̐
  GC.Hos4.est.func <- function(IC,t,y)
   {RSS.func <- function(b){temp <- y-GC.Hos4.func(b[1], b[2], b[3], t);   t(temp)%*%temp}
    res <- optim(IC, RSS.func)
    parm.est <- res$par;   prediction <- GC.Hos4.func(parm.est[1], parm.est[2], parm.est[3], t)
    rss <- t(y-prediction)%*%(y-prediction)
    list(parameter=parm.est, RSS=rss, pred=prediction)
    }
  GC.Gom.est.func <- function(IC,t,y)
   {RSS.func <- function(b){temp <- y-GC.Gom.func(b[1], b[2], b[3], t);   t(temp)%*%temp}
    res <- optim(IC, RSS.func)
    parm.est <- res$par;   prediction <- GC.Gom.func(parm.est[1], parm.est[2], parm.est[3], t)
    rss <- t(y-prediction)%*%(y-prediction)
    list(parameter=parm.est, RSS=rss, pred=prediction)
    }
  GC.Log.est.func <- function(IC,t,y)
   {RSS.func <- function(b){temp <- y-GC.Log.func(b[1], b[2], b[3], t);   t(temp)%*%temp}
    res <- optim(IC, RSS.func)
    parm.est <- res$par;   prediction <- GC.Log.func(parm.est[1], parm.est[2], parm.est[3], t)
    rss <- t(y-prediction)%*%(y-prediction)
    list(parameter=parm.est, RSS=rss, pred=prediction)
    }
  GC.Mon.est.func <- function(IC,t,y)
   {RSS.func <- function(b){temp <- y-GC.Mon.func(b[1], b[2], b[3], t);   t(temp)%*%temp}
    res <- optim(IC, RSS.func)
    parm.est <- res$par;   prediction <- GC.Mon.func(parm.est[1], parm.est[2], parm.est[3], t)
    rss <- t(y-prediction)%*%(y-prediction)
    list(parameter=parm.est, RSS=rss, pred=prediction)
    }
  GC.Ber.est.func <- function(IC,t,y)
   {RSS.func <- function(b){temp <- y-GC.Ber.func(b[1], b[2], t);   t(temp)%*%temp}
    res <- optim(IC, RSS.func)
    parm.est <- res$par;   prediction <- GC.Ber.func(parm.est[1], parm.est[2], t)
    rss <- t(y-prediction)%*%(y-prediction)
    list(parameter=parm.est, RSS=rss, pred=prediction)
    }
  GC.CR.est.func <- function(IC,t,y)
   {RSS.func <- function(b){temp <- y-GC.CR.func(b[1], b[2], b[3], t);   t(temp)%*%temp}
    res <- optim(IC, RSS.func)
    parm.est <- res$par;   prediction <- GC.CR.func(parm.est[1], parm.est[2], parm.est[3], t)
    rss <- t(y-prediction)%*%(y-prediction)
    list(parameter=parm.est, RSS=rss, pred=prediction)
    }
  GC.Lev1.est.func <- function(IC,t,y)
   {RSS.func <- function(b){temp <- y-GC.Lev1.func(b[1], b[2], b[3], b[4], t);   t(temp)%*%temp}
    res <- optim(IC, RSS.func)
    parm.est <- res$par;   prediction <- GC.Lev1.func(parm.est[1], parm.est[2], parm.est[3], parm.est[4], t)
    rss <- t(y-prediction)%*%(y-prediction)
    list(parameter=parm.est, RSS=rss, pred=prediction)
    }
  GC.Lev3.est.func <- function(IC,t,y)
   {RSS.func <- function(b){temp <- y-GC.Lev3.func(b[1], b[2], b[3], t);   t(temp)%*%temp}
    res <- optim(IC, RSS.func)
    parm.est <- res$par;   prediction <- GC.Lev3.func(parm.est[1], parm.est[2], parm.est[3], t)
    rss <- t(y-prediction)%*%(y-prediction)
    list(parameter=parm.est, RSS=rss, pred=prediction)
    }
  GC.Kor.est.func <- function(IC,t,y)
   {RSS.func <- function(b){temp <- y-GC.Kor.func(b[1], b[2], b[3], t);   t(temp)%*%temp}
    res <- optim(IC, RSS.func)
    parm.est <- res$par;   prediction <- GC.Kor.func(parm.est[1], parm.est[2], parm.est[3], t)
    rss <- t(y-prediction)%*%(y-prediction)
    list(parameter=parm.est, RSS=rss, pred=prediction)
    }
  GC.Wei.est.func <- function(IC,t,y)
   {RSS.func <- function(b){temp <- y-GC.Wei.func(b[1], b[2], b[3], t);   t(temp)%*%temp}
    res <- optim(IC, RSS.func)
    parm.est <- res$par;   prediction <- GC.Wei.func(parm.est[1], parm.est[2], parm.est[3], t)
    rss <- t(y-prediction)%*%(y-prediction)
    list(parameter=parm.est, RSS=rss, pred=prediction)
    }
  GC.Yos1.est.func <- function(IC,t,y)
   {RSS.func <- function(b){temp <- y-GC.Yos1.func(b[1], b[2], b[3], b[4], t);   t(temp)%*%temp}
    res <- optim(IC, RSS.func)
    parm.est <- res$par;   prediction <- GC.Yos1.func(parm.est[1], parm.est[2], parm.est[3], parm.est[4], t)
    rss <- t(y-prediction)%*%(y-prediction)
    list(parameter=parm.est, RSS=rss, pred=prediction)
    }
  GC.Slo.est.func <- function(IC,t,y)
   {RSS.func <- function(b){temp <- y-GC.Slo.func(b[1], b[2], b[3], b[4], t);   t(temp)%*%temp}
    res <- optim(IC, RSS.func)
    parm.est <- res$par;   prediction <- GC.Slo.func(parm.est[1], parm.est[2], parm.est[3], parm.est[4], t)
    rss <- t(y-prediction)%*%(y-prediction)
    list(parameter=parm.est, RSS=rss, pred=prediction)
    }

 # ֐̖O
  GC.name <- c("Hossfeld4", "Gompertz", "Logistic", "Monomolecular",
               "Bertalanffy", "Richards", "Levakovic1", "Levakovic3",
               "Korf", "Weibull", "Yoshida", "Sloboda", "Full")
  
 # ֐̖mp[^
  GC.ParNum <- c(3, 3, 3, 3, 2, 3, 4, 3, 3, 3, 4, 4, 16)  # mp[^

 # ֐mp[^̏li3ށj
  IV.cand1.func <- function(num)
   {if (num==1) {res <- c(100,15,4.35)};      if (num==2) {res <- c(100,10,0.5)}
    if (num==3) {res <- c(100,0.7,60)};       if (num==4) {res <- c(100,2.2,0.3)}
    if (num==5) {res <- c(100,0.4)};          if (num==6) {res <- c(100,0.1,0.5)}
    if (num==7) {res <- c(100,80,1.5,3.1)};   if (num==8) {res <- c(100,40,0.5)}
    if (num==9) {res <- c(100,11,1.4)};       if (num==10) {res <- c(100,0.2,1)}
    if (num==11) {res <- c(100,4,10,1)};      if (num==12) {res <- c(100,4,0.35,1.1)}
    res
    }
  
  IV.cand2.func <- function(num)
   {if (num==1) {res <- c(100,12,2.6)};       if (num==2) {res <- c(100,6,0.3)}
    if (num==3) {res <- c(100,0.5,24)};       if (num==4) {res <- c(100,1.5,0.2)}
    if (num==5) {res <- c(100,0.2)};          if (num==6) {res <- c(100,0.3,3.5)}
    if (num==7) {res <- c(100,34,2,2)};       if (num==8) {res <- c(100,8,5)}
    if (num==9) {res <- c(100,19,1.5)};       if (num==10) {res <- c(100,0.02,2)}
    if (num==11) {res <- c(100,40,2.5,1)};    if (num==12) {res <- c(100,18,1,0.5)}
    res
    }

  IV.cand3.func <- function(num)
   {if (num==1) {res <- c(20,15,4.35)};      if (num==2) {res <- c(20,10,0.5)}
    if (num==3) {res <- c(20,0.7,60)};       if (num==4) {res <- c(20,2.2,0.3)}
    if (num==5) {res <- c(20,0.4)};          if (num==6) {res <- c(20,0.1,0.5)}
    if (num==7) {res <- c(20,80,1.5,3.1)};   if (num==8) {res <- c(20,40,0.5)}
    if (num==9) {res <- c(20,11,1.4)};       if (num==10) {res <- c(20,0.2,1)}
    if (num==11) {res <- c(18,1,1,1)};       if (num==12) {res <- c(20,4,0.35,1.1)}
    res
    }

 # ֐ɊւʋK ------------------------------------------------------------
  
  # CpK
   GC.Cp.func <- function(t,y,iv.func)
    {n <- length(t)
     res1 <- GC.Hos4.est.func(iv.func(1), t, y)  # Hossfeld-4ɂ铖Ă͂
     res2 <- GC.Gom.est.func(iv.func(2), t, y)   # Gompertzɂ铖Ă͂
     res3 <- GC.Log.est.func(iv.func(3), t, y)   # Logisticɂ铖Ă͂
     res4 <- GC.Mon.est.func(iv.func(4), t, y)   # Monomolecularɂ铖Ă͂
     res5 <- GC.Ber.est.func(iv.func(5), t, y)   # Bertlanffyɂ铖Ă͂
     res6 <- GC.CR.est.func(iv.func(6), t, y) # Chapman-Richardsɂ铖Ă͂
     res7 <- GC.Lev1.est.func(iv.func(7), t, y)  # Levacovic-1ɂ铖Ă͂
     res8 <- GC.Lev3.est.func(iv.func(8), t, y)  # Levacovic-3ɂ铖Ă͂
     res9 <- GC.Kor.est.func(iv.func(9), t, y)   # Korfɂ铖Ă͂
     res10 <- GC.Wei.est.func(iv.func(10), t, y) # Weibullɂ铖Ă͂
     res11 <- GC.Yos1.est.func(iv.func(11), t, y) # Yoshida-1ɂ铖Ă͂
     res12 <- GC.Slo.est.func(iv.func(12), t, y) # Slobodaɂ铖Ă͂
    
     RSS <- Var <- c(1:12)                            # caƕU̎Zo
     RSS[1] <- res1$RSS;     Var[1] <- RSS[1]/(n-GC.ParNum[1])
     RSS[2] <- res2$RSS;     Var[2] <- RSS[2]/(n-GC.ParNum[2])
     RSS[3] <- res3$RSS;     Var[3] <- RSS[3]/(n-GC.ParNum[3])
     RSS[4] <- res4$RSS;     Var[4] <- RSS[4]/(n-GC.ParNum[4])
     RSS[5] <- res5$RSS;     Var[5] <- RSS[5]/(n-GC.ParNum[5])
     RSS[6] <- res6$RSS;     Var[6] <- RSS[6]/(n-GC.ParNum[6])
     RSS[7] <- res7$RSS;     Var[7] <- RSS[7]/(n-GC.ParNum[7])
     RSS[8] <- res8$RSS;     Var[8] <- RSS[8]/(n-GC.ParNum[8])
     RSS[9] <- res9$RSS;     Var[9] <- RSS[9]/(n-GC.ParNum[9])
     RSS[10] <- res10$RSS;   Var[10] <- RSS[10]/(n-GC.ParNum[10])
     RSS[11] <- res11$RSS;   Var[11] <- RSS[11]/(n-GC.ParNum[11])
     RSS[12] <- res12$RSS;   Var[12] <- RSS[12]/(n-GC.ParNum[12])
     
     min.var <- min(Var)                                    # tf̐
     if(min.var==Var[1]){iv <- c(1,res1$parameter,1,rep(0,11))}
     if(min.var==Var[2]){iv <- c(rep(0,12),res2$parameter,-1)}
     if(min.var==Var[3]){iv <- c(0,0,0,0,0,res3$parameter,-1,rep(0,7))}
     if(min.var==Var[4]){iv <- c(0,0,0,0,0,res4$parameter,1,rep(0,7))}
     if(min.var==Var[5]) 
      {iv <- c(0,0,0,0,0,res5$parameter[1],1,res5$parameter[2],3,rep(0,7))}
     if(min.var==Var[6]) 
      {iv <- c(0,0,0,0,0,res6$parameter[1],1,res6$parameter[2:3],rep(0,7))}
     if(min.var==Var[7]) 
      {iv <- c(res7$parameter[1:2],1,res7$parameter[3:4],rep(0,11))}
     if(min.var==Var[8]) 
      {iv <- c(res8$parameter[1:2],1,2,res8$parameter[3],rep(0,11))}
     if(min.var==Var[9]){iv <- c(rep(0,9),res9$parameter[1:3],0,0,0,0)}
     if(min.var==Var[10]) 
      {iv <- c(res10$parameter[1],rep(0,8),-res10$parameter[1],
               res10$parameter[2:3],0,0,0,0)}
     if(min.var==Var[11]) 
      {iv <- c(res11$parameter[1:2],1,res11$parameter[3],1,
               res11$parameter[4],rep(0,10))}
     if(min.var==Var[12]){iv <- c(rep(0,12),res12$parameter)}
     
     RSS.FM.func <- function(b) 
      {temp <- y-GC.Full.func(b[1], b[2], b[3], b[4], b[5], b[6], b[7], b[8],
                              b[9], b[10], b[11], b[12], b[13], b[14], b[15],
                              b[16], t)
       t(temp)%*%temp
       }
     beta.FM <- optim(iv, RSS.FM.func, control=list(maxit=10000))$par
     y.hat.FM <- GC.Full.func(beta.FM[1], beta.FM[2], beta.FM[3], beta.FM[4],
                              beta.FM[5], beta.FM[6], beta.FM[7], beta.FM[8],
                              beta.FM[9], beta.FM[10], beta.FM[11], 
                              beta.FM[12], beta.FM[13], beta.FM[14],
                              beta.FM[15], beta.FM[16], t)
     
     RSS.FM <- t(y-y.hat.FM)%*%(y-y.hat.FM)           # tf̎ca
     Var.FM <- RSS.FM/(n-GC.ParNum[13])          # tf̐蕪Ul
     
     Cp <- c(1:12)                                                  # CpK
     Cp[1] <- RSS[1] + 2*Var.FM*GC.ParNum[1]
     Cp[2] <- RSS[2] + 2*Var.FM*GC.ParNum[2]
     Cp[3] <- RSS[3] + 2*Var.FM*GC.ParNum[3]
     Cp[4] <- RSS[4] + 2*Var.FM*GC.ParNum[4]
     Cp[5] <- RSS[5] + 2*Var.FM*GC.ParNum[5]
     Cp[6] <- RSS[6] + 2*Var.FM*GC.ParNum[6]
     Cp[7] <- RSS[7] + 2*Var.FM*GC.ParNum[7]
     Cp[8] <- RSS[8] + 2*Var.FM*GC.ParNum[8]
     Cp[9] <- RSS[9] + 2*Var.FM*GC.ParNum[9]
     Cp[10] <- RSS[10] + 2*Var.FM*GC.ParNum[10]
     Cp[11] <- RSS[11] + 2*Var.FM*GC.ParNum[11]
     Cp[12] <- RSS[12] + 2*Var.FM*GC.ParNum[12]
     
     if(Cp[1] == min(Cp)){res <-1;   y.hat <- res1$pred}@@       # Cpŏf
     if(Cp[2] == min(Cp)){res <-2;   y.hat <- res2$pred}
     if(Cp[3] == min(Cp)){res <-3;   y.hat <- res3$pred}
     if(Cp[4] == min(Cp)){res <-4;   y.hat <- res4$pred}
     if(Cp[5] == min(Cp)){res <-5;   y.hat <- res5$pred}
     if(Cp[6] == min(Cp)){res <-6;   y.hat <- res6$pred}
     if(Cp[7] == min(Cp)){res <-7;   y.hat <- res7$pred}
     if(Cp[8] == min(Cp)){res <-8;   y.hat <- res8$pred}
     if(Cp[9] == min(Cp)){res <-9;   y.hat <- res9$pred}
     if(Cp[10] == min(Cp)){res <-10;   y.hat <- res10$pred}
     if(Cp[11] == min(Cp)){res <-11;   y.hat <- res11$pred}
     if(Cp[12] == min(Cp)){res <-12;   y.hat <- res12$pred}
     
     list(BestNum=res, Val=min(Cp), All=Cp, RSS.all=RSS, RSS.full=RSS.FM, 
          Predict=y.hat)
   }

  # CVK
   GC.CV.func <- function(t,y,iv.func)
    {n <- length(t);   CV <- c(rep(0,12))
     
     for (i in 1:n)                                       # WbNiCt
      {t.j <- t[-i];   y.j <- y[-i]
       beta <- GC.Hos4.est.func(iv.func(1), t.j, y.j)$parameter
        y.hat <- GC.Hos4.func(beta[1], beta[2], beta[3], t)
        CV[1] <- CV[1] + (y[i]-y.hat[i])^2
       beta <- GC.Gom.est.func(iv.func(2), t.j, y.j)$parameter
        y.hat <- GC.Gom.func(beta[1], beta[2], beta[3], t)
        CV[2] <- CV[2] + (y[i]-y.hat[i])^2
       beta <- GC.Log.est.func(iv.func(3), t.j, y.j)$parameter
        y.hat <- GC.Log.func(beta[1], beta[2], beta[3], t)
        CV[3] <- CV[3] + (y[i]-y.hat[i])^2
       beta <- GC.Mon.est.func(iv.func(4), t.j, y.j)$parameter
        y.hat <- GC.Mon.func(beta[1], beta[2], beta[3], t)
        CV[4] <- CV[4] + (y[i]-y.hat[i])^2
       beta <- GC.Ber.est.func(iv.func(5), t.j, y.j)$parameter
        y.hat <- GC.Ber.func(beta[1], beta[2], t)
        CV[5] <- CV[5] + (y[i]-y.hat[i])^2
       beta <- GC.CR.est.func(iv.func(6), t.j, y.j)$parameter
        y.hat <- GC.CR.func(beta[1], beta[2], beta[3], t)
        CV[6] <- CV[6] + (y[i]-y.hat[i])^2
       beta <- GC.Lev1.est.func(iv.func(7), t.j, y.j)$parameter
        y.hat <- GC.Lev1.func(beta[1], beta[2], beta[3], beta[4], t)
        CV[7] <- CV[7] + (y[i]-y.hat[i])^2
       beta <- GC.Lev3.est.func(iv.func(8), t.j, y.j)$parameter
        y.hat <- GC.Lev3.func(beta[1], beta[2], beta[3], t)
        CV[8] <- CV[8] + (y[i]-y.hat[i])^2
       beta <- GC.Kor.est.func(iv.func(9), t.j, y.j)$parameter
        y.hat <- GC.Kor.func(beta[1], beta[2], beta[3], t)
        CV[9] <- CV[9] + (y[i]-y.hat[i])^2
       beta <- GC.Wei.est.func(iv.func(10), t.j, y.j)$parameter
        y.hat <- GC.Wei.func(beta[1], beta[2], beta[3], t)
        CV[10] <- CV[10] + (y[i]-y.hat[i])^2
       beta <- GC.Yos1.est.func(iv.func(11), t.j, y.j)$parameter
        y.hat <- GC.Yos1.func(beta[1], beta[2], beta[3], beta[4], t)
        CV[11] <- CV[11] + (y[i]-y.hat[i])^2
       beta <- GC.Slo.est.func(iv.func(12), t.j, y.j)$parameter
        y.hat <- GC.Slo.func(beta[1], beta[2], beta[3], beta[4], t)
        CV[12] <- CV[12] + (y[i]-y.hat[i])^2
       }
       
     if(CV[1]==min(CV))                                        # CVŏf
      {res <-1;   y.hat <- GC.Hos4.est.func(iv.func(1), t, y)$pred}
     if(CV[2]==min(CV)) 
      {res <-2;   y.hat <- GC.Gom.est.func(iv.func(2), t, y)$pred}
     if(CV[3]==min(CV)) 
      {res <-3;   y.hat <- GC.Log.est.func(iv.func(3), t, y)$pred}
     if(CV[4]==min(CV)) 
      {res <-4;   y.hat <- GC.Mon.est.func(iv.func(4), t, y)$pred}
     if(CV[5]==min(CV)) 
      {res <-5;   y.hat <- GC.Ber.est.func(iv.func(5), t, y)$pred}
     if(CV[6]==min(CV)) 
      {res <-6;   y.hat <- GC.CR.est.func(iv.func(6), t, y)$pred}
     if(CV[7]==min(CV)) 
      {res <-7;   y.hat <- GC.Lev1.est.func(iv.func(7), t, y)$pred}
     if(CV[8]==min(CV)) 
      {res <-8;   y.hat <- GC.Lev3.est.func(iv.func(8), t, y)$pred}
     if(CV[9]==min(CV)) 
      {res <-9;   y.hat <- GC.Kor.est.func(iv.func(9), t, y)$pred}
     if(CV[10]==min(CV)) 
      {res <-10;   y.hat <- GC.Wei.est.func(iv.func(10), t, y)$pred}
     if(CV[11]==min(CV)) 
      {res <-11;   y.hat <- GC.Yos1.est.func(iv.func(11), t, y)$pred}
     if(CV[12]==min(CV)) 
      {res <-12;   y.hat <- GC.Slo.est.func(iv.func(12), t, y)$pred}
     
     list(BestNum=res, Val=min(CV), All=CV, Predict=y.hat)
     }

  # AICK
   GC.AIC.func <- function(t,y,iv.func)
    {n <- length(t)
     res1 <- GC.Hos4.est.func(iv.func(1), t, y)  # Hossfeld-4ɂ铖Ă͂
     res2 <- GC.Gom.est.func(iv.func(2), t, y)   # Gompertzɂ铖Ă͂
     res3 <- GC.Log.est.func(iv.func(3), t, y)   # Logisticɂ铖Ă͂
     res4 <- GC.Mon.est.func(iv.func(4), t, y)   # Monomolecularɂ铖Ă͂
     res5 <- GC.Ber.est.func(iv.func(5), t, y)   # Bertlanffyɂ铖Ă͂
     res6 <- GC.CR.est.func(iv.func(6), t, y) # Chapman-Richardsɂ铖Ă͂
     res7 <- GC.Lev1.est.func(iv.func(7), t, y)  # Levacovic-1ɂ铖Ă͂
     res8 <- GC.Lev3.est.func(iv.func(8), t, y)  # Levacovic-3ɂ铖Ă͂
     res9 <- GC.Kor.est.func(iv.func(9), t, y)   # Korfɂ铖Ă͂
     res10 <- GC.Wei.est.func(iv.func(10), t, y) # Weibullɂ铖Ă͂
     res11 <- GC.Yos1.est.func(iv.func(11), t, y) # Yoshida-1ɂ铖Ă͂
     res12 <- GC.Slo.est.func(iv.func(12), t, y) # Slobodaɂ铖Ă͂
     
     RSS <- Var <- c(1:12)                                         # ca
     RSS[1] <- res1$RSS;     RSS[2] <- res2$RSS;     RSS[3] <- res3$RSS
     RSS[4] <- res4$RSS;     RSS[5] <- res5$RSS;     RSS[6] <- res6$RSS
     RSS[7] <- res7$RSS;     RSS[8] <- res8$RSS;     RSS[9] <- res9$RSS
     RSS[10] <- res10$RSS;   RSS[11] <- res11$RSS;   RSS[12] <- res12$RSS
     
     AIC <- c(1:12)                                                 # AIC̎Zo
     AIC[1] <- n*(log(2*pi)+log(RSS[1]/n)+1)+2*GC.ParNum[1]
     AIC[2] <- n*(log(2*pi)+log(RSS[2]/n)+1)+2*GC.ParNum[2]
     AIC[3] <- n*(log(2*pi)+log(RSS[3]/n)+1)+2*GC.ParNum[3]
     AIC[4] <- n*(log(2*pi)+log(RSS[4]/n)+1)+2*GC.ParNum[4]
     AIC[5] <- n*(log(2*pi)+log(RSS[5]/n)+1)+2*GC.ParNum[5]
     AIC[6] <- n*(log(2*pi)+log(RSS[6]/n)+1)+2*GC.ParNum[6]
     AIC[7] <- n*(log(2*pi)+log(RSS[7]/n)+1)+2*GC.ParNum[7]
     AIC[8] <- n*(log(2*pi)+log(RSS[8]/n)+1)+2*GC.ParNum[8]
     AIC[9] <- n*(log(2*pi)+log(RSS[9]/n)+1)+2*GC.ParNum[9]
     AIC[10] <- n*(log(2*pi)+log(RSS[10]/n)+1)+2*GC.ParNum[10]
     AIC[11] <- n*(log(2*pi)+log(RSS[11]/n)+1)+2*GC.ParNum[11]
     AIC[12] <- n*(log(2*pi)+log(RSS[12]/n)+1)+2*GC.ParNum[12]
     
     if(AIC[1]==min(AIC)){res <-1;   y.hat <- res1$pred}        # AICŏf
     if(AIC[2]==min(AIC)){res <-2;   y.hat <- res2$pred}
     if(AIC[3]==min(AIC)){res <-3;   y.hat <- res3$pred}
     if(AIC[4]==min(AIC)){res <-4;   y.hat <- res4$pred}
     if(AIC[5]==min(AIC)){res <-5;   y.hat <- res5$pred}
     if(AIC[6]==min(AIC)){res <-6;   y.hat <- res6$pred}
     if(AIC[7]==min(AIC)){res <-7;   y.hat <- res7$pred}
     if(AIC[8]==min(AIC)){res <-8;   y.hat <- res8$pred}
     if(AIC[9]==min(AIC)){res <-9;   y.hat <- res9$pred}
     if(AIC[10]==min(AIC)){res <-10;   y.hat <- res10$pred}
     if(AIC[11]==min(AIC)){res <-11;   y.hat <- res11$pred}
     if(AIC[12]==min(AIC)){res <-12;   y.hat <- res12$pred}
     list(BestNum=res, Val=min(AIC), All=AIC, Predict=y.hat)
     }



# 
 # xǗ}̃p[^
  par.sdmd <- c(0.068509, 1.347565, 2658.2, 2.814651, 0.791213, 0.244012, 
                0.353895, 0.048940, 0.034814, 0.98937, 3470890, 0.9184, 0.05, 1)

 # XNvgQDR --------------------------------------------------------
  growth.sdmd.func <- function(p, time, N0)
   {N <- c(rep(2918,length(time)))                                  # ؖ{
    H1 <- exp(p[13])*exp(-exp(p[14])*time^(-exp(p[15])))
    v1 <- 1/(exp(p[1])*N*H1^(-exp(p[2]))+exp(p[3])*H1^(-exp(p[4]))) # (2.1)
    V <- v1*N                                                       # (2.2)
    HF <- exp(p[5])+exp(p[6])*H1*sqrt(N)/100+exp(p[7])*H1           # (2.3)
    G <- V/HF                                                       # (2.4)
    Dg <- 200*sqrt(G/(pi*N))                                        # (2.5)
    D1 <- -exp(p[8])-exp(p[9])*H1*sqrt(N)/100 + exp(p[10])*Dg       # (2.6)
    N1 <- (1/N0 + v1/(exp(p[11])*N0^(-exp(p[12]))))^(-1)            # (2.7)
    cbind(time, H1, D1, N1, v1)
    }

 # XNvgQDT --------------------------------------------------------
  FS.sdmd.func <- function(p, t, D, H, v, N0)
   {N <- 1:length(t);   N[]<-N0
    dif <- matrix(0, length(t), 4)
    H1 <- exp(p[13])*exp(-exp(p[14])*t^(-exp(p[15])))
    dif[,1] <- H1 - H
    v1 <- 1/(exp(p[1])*N*H1^(-exp(p[2]))+exp(p[3])*H1^(-exp(p[4]))) # (2.1)
    dif[,2] <- v1-v
    V <- v1*N                                                       # (2.2)
    HF <- exp(p[5])+exp(p[6])*H1*sqrt(N)/100+exp(p[7])*H1           # (2.3)
    G <- (V/HF)                                                     # (2.4)
    Dg <- 200*sqrt((G/(pi*N)))                                      # (2.5)
    D1 <- -exp(p[8])-exp(p[9])*H1*sqrt(N)/100+exp(p[10])*Dg         # (2.6)
    dif[,3] <- D1-D
    sum(dif^2)                                                     # (2.11)
    }

 # XNvgQDU --------------------------------------------------------
  SD.sdmd.func <- function(p, t, D, H, v, N0)
   {N <- 1:length(t);   N[]<- N0
    dif <- matrix(0, length(t), 3)
    H1 <- exp(p[13])*exp(-exp(p[14])*t^(-exp(p[15])))
    dif[,1] <- H1-H
    v1 <- 1/(exp(p[1])*N*H1^(-exp(p[2]))+exp(p[3])*H1^(-exp(p[4]))) # (2.1)
    dif[,2] <- v1-v
    V <- v1*N                                                       # (2.2)
    HF <- exp(p[5])+exp(p[6])*H1*sqrt(N)/100+exp(p[7])*H1           # (2.3)
    G <- (V/HF)                                                     # (2.4)
    Dg <- 200*sqrt((G/(pi*N)))                                      # (2.5)
    D1 <- -exp(p[8])-exp(p[9])*H1*sqrt(N)/100+exp(p[10])*Dg         # (2.6)
    dif[,3] <- D1-D
    sigma <- matrix(0, 3, 3)
    for(i in 1:length(H1)) {sigma<-sigma+dif[i,]%*%t(dif[i,])}
    sigma <- sigma/length(t)                                       # (2.12)
    SD <- c(0)
    for(i in 1:length(t)){SD <- SD+t(dif[i,])%*%solve(sigma)%*%dif[i,]}
    SD                                                             # (2.13)
    }
  


# O
 # XNvgRDQ --------------------------------------------------------
  Est1.GMANOVA.func <- function(A, X, Y)                         # ̐
   {n <- dim(Y)[1];   k <- dim(A)[2]
    Pa <- A%*%solve(t(A)%*%A)%*%t(A);   In <- diag(1,n)  # ˉesƒPʍs
    S <- t(Y)%*%(In-Pa)%*%Y/(n-k)
    solve(t(A)%*%A)%*%t(A)%*%Y%*%solve(S)%*%X%*%solve(t(X)%*%solve(S)%*%X)
    }
    
  Est2.GMANOVA.func <- function(A, X, Y)                         # ̐
   {n <- dim(Y)[1];   k <- dim(A)[2]
    Pa <- A%*%solve(t(A)%*%A)%*%t(A);   In <- diag(1,n)
    S <- t(Y)%*%(In-Pa)%*%Y / (n-k)
    xi <- Est1.GMANOVA.func(A,X,Y)
    t(Y-A%*%xi%*%t(X))%*%(Y-A%*%xi%*%t(X))/n
    }

 # XNvgRDS --------------------------------------------------------
  Tst.GMANOVA.func <- function(A,X,Y,C,D)
   {n <- dim(Y)[1];   p <- dim(Y)[2];   k <- dim(A)[2];   q <- dim(X)[2]
    c <- qr(C)$rank;   d <- qr(D)$rank
    Pa <- A%*%solve(t(A)%*%A)%*%t(A);   In <- diag(1,n)
    S <- t(Y)%*%(In-Pa)%*%Y
    R <- solve(S)-solve(S)%*%X%*%solve(t(X)%*%solve(S)%*%X)%*%t(X)%*%solve(S)
    R <- solve(t(A)%*%A)%*%t(A)%*%Y%*%R%*%t(Y)%*%A%*%solve(t(A)%*%A)
    R <- (solve(t(A)%*%A)+R)/(n-k)                                 # (3.30)
    xi <- Est1.GMANOVA.func(A,X,Y)                     # ̐ʁF(3.16)
    Se <- (n-k)*t(D)%*%solve(t(X)%*%solve(S)%*%X)%*%D              # (3.28)
    Sh <- t(C%*%xi%*%D)%*%solve(C%*%R%*%t(C))%*%C%*%xi%*%D         # (3.29)
    Lamda <- det(Se)/det(Se+Sh)
    -(n-k-(p-q)-(d-c+1)/2)*log(Lamda)                              # (3.27)
    }



# l
 # mp[^̐iXNvgSDPj ---------------------------------
  Theta.func <- function(X, Y) {solve(t(X)%*%X)%*%t(X)%*%Y}      # ̐
  Sigma.func <- function(X, Y)                                   # ̐
   {n <- dim(X)[1];   In <- diag(1,n);   Px <- X%*%solve(t(X)%*%X)%*%t(X)
    (1/n)*t(Y)%*%(In-Px)%*%Y 
    }

 # mFKPiXNvgSDQj ---------------------------------------
  CV1.func <- function(X, Y)
   {n <- dim(Y)[1];   p <- dim(Y)[2];   k <- dim(X)[2]
    temp <- 0
    for(i in 1:n)                                        # WbNiCt
     {xi <- as.matrix(X[i,], ncol=1);   yi <- as.matrix(Y[i,], ncol=1)
      Xi <- X[-i,];   Yi <- Y[-i,]
      Theta <- Theta.func(Xi,Yi);   Sigma <- Sigma.func(Xi,Yi)
      temp <- temp+log(det(Sigma))
      temp <- temp+t(yi-t(Theta)%*%xi)%*%solve(Sigma)%*%(yi-t(Theta)%*%xi)
      }
    n*p*log(2*pi)+temp
    }

 # ԒrʋKiXNvgSDTj  ---------------------------------------
  AIC.func <- function(X,Y)
   {n <- dim(Y)[1];   p <- dim(Y)[2];   k <- dim(X)[2]
    Theta <- Theta.func(X,Y)                                      # ̐
    Sigma <- Sigma.func(X,Y)                                      # ̐
    n*p*(log(2*pi)+1) + n*log(det(Sigma))+2*(p*k+p*(p+1)/2)
    }

 # ʉWiXNvgSDVj----------------------------------------
  GCD.func <- function(X,Y)
   {Px <- X %*% solve(t(X)%*%X) %*% t(X)                           # ˉes
    Py <- Y %*% solve(t(Y)%*%Y) %*% t(Y)
    sum(diag(Px%*%Py)) / qr(t(X)%*%Y)$rank
    }

 # mFKQiXNvgSDPQj -------------------------------------
  CV2.func <- function(X,Y)
   {n <- dim(Y)[1];   p <- dim(Y)[2];   k <- dim(X)[2]
    Theta <- Theta.func(X,Y)
    Sigma <- Sigma.func(X,Y)
    temp <- 0
    for(i in 1:n)
     {xi <- as.matrix(X[i,], ncol=1);   yi <- as.matrix(Y[i,], ncol=1)
      hi <- 1-t(xi)%*%solve(t(X)%*%X)%*%xi
      ri2 <- t(yi-t(Theta)%*%xi)%*%solve(Sigma)%*%(yi-t(Theta)%*%xi)
      temp <- temp+log(1-(ri2/(n*hi)))+((n-1)*ri2)/(hi*(n*hi-ri2))
      }
    n*p*log(2*pi*n/(n-1))+n*log(det(Sigma))+temp
    }

 # XNvgSDPR -------------------------------------------------------
  nishin.func <- function(n)                         # POi@˂Qi@̊֐
   {temp <- n;   res <- 0;   k <- 0
    while(temp>=1) 
     {res <- res+temp%%2*10^k;   k <- k+1;   temp <- temp %/% 2 }
    res
    }

X.cand.func <- function(N, X.full)                 # ϐs̍쐬֐
 {n <- dim(X.full)[1];   temp <- nishin.func(N);   i <- 0;   X <- NULL
  while(temp>=1) 
   {if(temp%%10==1){X <- cbind(X.full[,dim(X.full)[2]-i], X)} 
    temp <- temp%/%10;   i <- i+1
    }
  cbind(c(rep(1,n)), X)
  }

var.vec.func <- function(N, X.full)
 {n <- dim(X.full)[1];   p <- dim(X.full)[2];   temp <- nishin.func(N);   i <- 0
  variable <- c(rep(0,p));   var.num <- 0
  while (temp>=1)
   {if (temp%%10==1) {variable[p-i] <- 1;   var.num <- var.num+1}
    temp <- temp%/%10;   i <- i+1
    }
  variable
  }



# ܏
 # XNvgTDP --------------------------------------------------------
  # k-means Cluster analysis
  # RES<-KCLUS(Y,km,itm,nm,Clus)
  # RES(k,1:n): k̃NX^[̂Ƃ̃NX^[
  #
  #   Y:n~p f[^s,  km:őNX^[,  itm:őJԂ
  #           nm:ŏNX^[W{,  clus:œK@(1 g[X, 2 s)
  
  KCLUS <- function(Y, km, itm, nm, clus)
   {n <- length(Y[,1]);   p <- length(Y[1,]);   RES <- matrix(0,km,n)
    RES0 <- RES;   CV <- RES;   DD <- CV;   D <- DD;   k <- 1
    RES[k,] <- 1
    for(k in 2:km)
     {print(paste(k,"̃NX^[̍œK"))
      RES0 <- rep(0,n);   CV <- t(c(1:k));   it <- 1;   itIND <- 1;
      INF0IND <- 0
      while(itIND==1)
       {DpIND <- 1;
        while(DpIND==1)
         {DIND <- round(runif(n,1,k))
          D <- matrix(0,n,k)
          for(i in 1:n){D[i,DIND[i]] <- 1}
          NM <- colSums(D);
          DpIND <- 0;
          for(j in 1:k){if (NM[j]<=nm) {DpIND <- 1}}
          }
        CIND <- 1;
        W <- t(Y)%*%(diag(n)-D%*%solve(t(D)%*%D)%*%t(D))%*%Y
        M <- solve(t(D)%*%D)%*%t(D)%*%Y
        while(CIND==1)
         {DD <- D;   i <- 1;   NIND <- 1
          while(NIND==1)
           {JIND <- matrix(0,k,1);   d0 <- D[i,];   n0 <- t(d0) %*% NM
            M0 <- t(M) %*% d0;   a0 <- Y[i,] - M0
            for(j in 1:k)
             {n1 <- NM[j];   M1 <- (M[j,]);   a1 <- (Y[i,])-M1
              if(clus==1)
               {JIND[j] <- (n1/(n1+1))*t(a1)%*%a1-(n0/(n0-1))*t(a0)%*%a0}
              else
               {JIND[j] <- 1+(n1/(n1+1))*t(a1)%*%solve(W)%*%a1
                JIND[j] <- JIND[j] * (1-(n0/(n0-1))*t(a0)%*%solve(W)%*%a0)
                temp <- (t(a1)%*%solve(W)%*%a0)^2
                JIND[j] <- JIND[j] + (n0/(n0-1))*(n1/(n1+1))*temp
                }
              }
            MJIND <- min(JIND)
            RJIND <- rank(JIND)
            for(j in 1:k){if(RJIND[j]==1){MIND <- j}}
            D[i,] <- matrix(0,1,k)
            D[i,MIND] <- 1
            W <- t(Y)%*%(diag(n)-D%*%solve(t(D)%*%D)%*%t(D))%*%Y
            M <- solve(t(D)%*%D)%*%t(D)%*%Y
            NM <- colSums(D)
            i <- i+1
            for(j in 1:k)
             {if (NM[j]<=nm) {NIND <- 0;   CIND <- 0;   INF0IND <- 1}}
            if(i>n){NIND <- 0}
            }
          DDY <- sum(diag(t(DD)%*%D))
          if(DDY == n){CIND <- 0}
        }
        RES1 <- rep(0,n+1)
        RES1[1:n] <- CV%*%t(D)
        if(clus==1){DDX <- sum(diag(t(W)%*%W));   RES1[n+1] <- DDX}
        else {RES1[n+1] <- det(W)}
        if(it==1)
         {RES0 <- RES1
          if(INF0IND !=1)
           {if(clus==1)
             {print(paste(it,"Ԗڂ̍œK tr(W)=",RES0[n+1]))}
            else{print(paste(it,"Ԗڂ̍œK det(W)=",RES0[n+1]))}
            }
          }
        if(RES0[n+1]>RES1[n+1])
         {RES0 <- RES1
          if(clus==1) 
           {print(paste(it,"Ԗڂ̍œK tr(W)=",RES0[n+1]))}
          else{print(paste(it,"Ԗڂ̍œK det(W)=",RES0[n+1]))}
          }
        it <- it+1
        if(INF0IND==1){it <- it-1}
        INF0IND <- 0;
        if(it>itm){itIND <- 0}
        }
      RES[k,] <- RES0[1:n]
      }
    return(RES)
    }



# 
 # XNvgXDPV ------------------------------------------------------
  full.search.logit <- function(y, X.full)                   # @̊֐
   {res.aic <- NULL;   p <- dim(X.full)[2]
    for(i in 1:2^p)
     {temp <- nishin.func(i-1);   j <- 0;   X <- NULL
      variable <- c(rep(0,p));   var.num <- 0
      while(temp>=1) 
       {if(temp%%10==1) 
         {X <- cbind(X.full[,p-j], X)
          variable[p-j] <- 1;   var.num <- var.num+1
          } 
        temp <- temp%/%10;   j <- j+1 
        } 
      if(i==1){res <- glm(y~1, family=binomial)}
      if(i>1){res <- glm(y~X, family=binomial)}
      res.aic <- rbind(res.aic, c(var.num, variable ,res$aic))
@  @}
    res.aic
    }

 # ʕϐiXNvgXDPVj -------------------------------------------
  Direc.func <- function(angle)
   {res <- c(0,0,0,0)
    if(angle<=22.5 || angle>337.5){res[1] <- 1}
    if(angle>22.5 && angle<=67.5){res[1] <- 1;   res[2] <- 1}
    if(angle>67.5 && angle<=112.5){res[2] <- 1}
    if(angle>112.5 && angle<=157.5){res[2] <- 1;   res[3] <- 1}
    if(angle>157.5 && angle<=202.5){res[3] <- 1}
    if(angle>202.5 && angle<=247.5){res[3] <- 1;   res[4] <- 1}
    if(angle>247.5 && angle<=292.5){res[4] <- 1}
    if(angle>292.5 && angle<=337.5){res[1] <- 1;   res[4] <- 1}
    res
    }


