

# XNvgPDP --------------------------------------------------------
GC.Hos4.func <- function(a,b,c,t){(t^c)/(b+(t^c/a))}     # Hossfeld-4
GC.Gom.func <- function(a,b,c,t){a*exp(-b*exp(-c*t))}    # Gompertz
GC.Log.func <- function(a,b,c,t){a/(1+c*exp(-b*t))}      # Logistic
GC.Mon.func <- function(a,b,c,t){a*(1-b*exp(-c*t))}      # Monomolecular
GC.Ber.func <- function(a,b,t){a*(1-exp(-b*t))^3}        # Bertlanffy
GC.CR.func <- function(a,b,c,t){a*(1-exp(-b*t))^c}       # Chapman-Richards
GC.Lev1.func <- function(a,b,c,d,t){a*(t^d/(b+t^d))^c}   # Levacovic-1
GC.Lev3.func <- function(a,b,c,t){a*(t^2/(b+t^2))^c}     # Levacovic-3
GC.Kor.func <- function(a,b,c,t){a*exp(-b*t^(-c))}       # Korf
GC.Wei.func <- function(a,b,c,t){a*(1-exp(-b*t^(c)))}    # Weibull
GC.Yos1.func <- function(a,b,c,d,t){(a*t^d)/(b+t^d)+c}   # Yoshida-1
GC.Slo.func <- function(a,b,c,d,t){a*exp(-b*exp(-c*t^(d)))}  # Sloboda



# XNvgPDQ --------------------------------------------------------
source("Kankyo.R")                                     # Kankyo.R̓ǂݍ
t <- c(0:35)/6
plot(t, GC.Hos4.func(2,1,2,t), type="o", xlab="", ylab="")
lines(t, GC.Gom.func(2,5,1,t), type="o", pch=2)



# XNvgPDR --------------------------------------------------------
GC.ParNum <- c(3, 3, 3, 3, 2, 3, 4, 3, 3, 3, 4, 4, 16)  # mp[^

# ֐̖O
GC.name <- c("Hossfeld4", "Gompertz", "Logistic", "Monomolecular",
             "Bertalanffy", "Richards", "Levakovic1", "Levakovic3",
             "Korf", "Weibull", "Yoshida", "Sloboda", "Full")



# XNvgPDS --------------------------------------------------------
F <- read.csv("Hoshino_Growth.csv", header=T)             # f[^ǂݍ
ID1 <- F[F$ID==7,]                                        # ID=7̔o
plot(ID1$Age, ID1$DBH, xlab=" (N)", ylab="a (cm)")



# XNvgPDT --------------------------------------------------------
GC.Hos4.est.func <- function(IC,t,y)
 {RSS.func <- function(b)                        # caZo֐
   {temp <- y-GC.Hos4.func(b[1], b[2], b[3], t);   t(temp)%*%temp }
  res <- optim(IC, RSS.func)                           # ca̍ŏ
  parm.est <- res$par
  prediction <- GC.Hos4.func(parm.est[1], parm.est[2], parm.est[3], t)
  rss <- t(y-prediction)%*%(y-prediction)                     # ca
  list(parameter=parm.est, RSS=rss, pred=prediction)
  }



# XNvgPDU --------------------------------------------------------
source("Kankyo.R")
F <- read.csv("Hoshino_Growth.csv", header=T)
y <- F[F$ID==7,]$DBH;   t <- F[F$ID==7,]$Age
plot(t, y, xlab=" (N)", ylab="a (cm)")
# Hossfeld-4ɂ铖Ă͂
lines(t, GC.Hos4.est.func(c(20,25,4.35),t,y)$pred, type="l")



# XNvgPDV --------------------------------------------------------
GC.Cp.func <- function(t,y,iv.func)
 {n <- length(t)
  res1 <- GC.Hos4.est.func(iv.func(1), t, y)   # Hossfeld-4ɂ铖Ă͂
  res2 <- GC.Gom.est.func(iv.func(2), t, y)    # Gompertzɂ铖Ă͂
  res3 <- GC.Log.est.func(iv.func(3), t, y)    # Logisticɂ铖Ă͂
  res4 <- GC.Mon.est.func(iv.func(4), t, y)    # Monomolecularɂ铖Ă͂
  res5 <- GC.Ber.est.func(iv.func(5), t, y)    # Bertlanffyɂ铖Ă͂
  res6 <- GC.CR.est.func(iv.func(6), t, y)     # Chapman-Richardsɂ铖Ă͂
  res7 <- GC.Lev1.est.func(iv.func(7), t, y)   # Levacovic-1ɂ铖Ă͂
  res8 <- GC.Lev3.est.func(iv.func(8), t, y)   # Levacovic-3ɂ铖Ă͂
  res9 <- GC.Kor.est.func(iv.func(9), t, y)    # Korfɂ铖Ă͂
  res10 <- GC.Wei.est.func(iv.func(10), t, y)  # Weibullɂ铖Ă͂
  res11 <- GC.Yos1.est.func(iv.func(11), t, y) # Yoshida-1ɂ铖Ă͂
  res12 <- GC.Slo.est.func(iv.func(12), t, y)  # Slobodaɂ铖Ă͂
    
  RSS <- Var <- c(1:12)                            # caƕU̎Zo
  RSS[1] <- res1$RSS;     Var[1] <- RSS[1]/(n-GC.ParNum[1])
  RSS[2] <- res2$RSS;     Var[2] <- RSS[2]/(n-GC.ParNum[2])
  RSS[3] <- res3$RSS;     Var[3] <- RSS[3]/(n-GC.ParNum[3])
  RSS[4] <- res4$RSS;     Var[4] <- RSS[4]/(n-GC.ParNum[4])
  RSS[5] <- res5$RSS;     Var[5] <- RSS[5]/(n-GC.ParNum[5])
  RSS[6] <- res6$RSS;     Var[6] <- RSS[6]/(n-GC.ParNum[6])
  RSS[7] <- res7$RSS;     Var[7] <- RSS[7]/(n-GC.ParNum[7])
  RSS[8] <- res8$RSS;     Var[8] <- RSS[8]/(n-GC.ParNum[8])
  RSS[9] <- res9$RSS;     Var[9] <- RSS[9]/(n-GC.ParNum[9])
  RSS[10] <- res10$RSS;   Var[10] <- RSS[10]/(n-GC.ParNum[10])
  RSS[11] <- res11$RSS;   Var[11] <- RSS[11]/(n-GC.ParNum[11])
  RSS[12] <- res12$RSS;   Var[12] <- RSS[12]/(n-GC.ParNum[12])
  
  min.var <- min(Var)                                    # tf̐
  if(min.var==Var[1]){iv <- c(1,res1$parameter,1,rep(0,11))}
  if(min.var==Var[2]){iv <- c(rep(0,12),res2$parameter,-1)}
  if(min.var==Var[3]){iv <- c(0,0,0,0,0,res3$parameter,-1,rep(0,7))}
  if(min.var==Var[4]){iv <- c(0,0,0,0,0,res4$parameter,1,rep(0,7))}
  if(min.var==Var[5]) 
   {iv <- c(0,0,0,0,0,res5$parameter[1],1,res5$parameter[2],3,rep(0,7))}
  if(min.var==Var[6]) 
   {iv <- c(0,0,0,0,0,res6$parameter[1],1,res6$parameter[2:3],rep(0,7))}
  if(min.var==Var[7]) 
   {iv <- c(res7$parameter[1:2],1,res7$parameter[3:4],rep(0,11))}
  if(min.var==Var[8]) 
   {iv <- c(res8$parameter[1:2],1,2,res8$parameter[3],rep(0,11))}
  if(min.var==Var[9]){iv <- c(rep(0,9),res9$parameter[1:3],0,0,0,0)}
  if(min.var==Var[10]) 
   {iv <- c(res10$parameter[1],rep(0,8),-res10$parameter[1],
            res10$parameter[2:3],0,0,0,0)}
  if(min.var==Var[11]) 
   {iv <- c(res11$parameter[1:2],1,res11$parameter[3],1,
            res11$parameter[4],rep(0,10))}
  if(min.var==Var[12]){iv <- c(rep(0,12),res12$parameter)}
       
  RSS.FM.func <- function(b) 
   {temp <- y-GC.Full.func(b[1], b[2], b[3], b[4], b[5], b[6], b[7], b[8],
                           b[9], b[10], b[11], b[12], b[13], b[14], b[15],
                           b[16], t)
    t(temp)%*%temp
    }
  beta.FM <- optim(iv, RSS.FM.func, control=list(maxit=10000))$par
  y.hat.FM <- GC.Full.func(beta.FM[1], beta.FM[2], beta.FM[3], beta.FM[4],
                           beta.FM[5], beta.FM[6], beta.FM[7], beta.FM[8],
                           beta.FM[9], beta.FM[10], beta.FM[11], 
                           beta.FM[12], beta.FM[13], beta.FM[14],
                           beta.FM[15], beta.FM[16], t)
  
  RSS.FM <- t(y-y.hat.FM)%*%(y-y.hat.FM)           # tf̎ca
  Var.FM <- RSS.FM/(n-GC.ParNum[13])          # tf̐蕪Ul
  
  Cp <- c(1:12)                                                  # CpK
  Cp[1] <- RSS[1] + 2*Var.FM*GC.ParNum[1]
  Cp[2] <- RSS[2] + 2*Var.FM*GC.ParNum[2]
  Cp[3] <- RSS[3] + 2*Var.FM*GC.ParNum[3]
  Cp[4] <- RSS[4] + 2*Var.FM*GC.ParNum[4]
  Cp[5] <- RSS[5] + 2*Var.FM*GC.ParNum[5]
  Cp[6] <- RSS[6] + 2*Var.FM*GC.ParNum[6]
  Cp[7] <- RSS[7] + 2*Var.FM*GC.ParNum[7]
  Cp[8] <- RSS[8] + 2*Var.FM*GC.ParNum[8]
  Cp[9] <- RSS[9] + 2*Var.FM*GC.ParNum[9]
  Cp[10] <- RSS[10] + 2*Var.FM*GC.ParNum[10]
  Cp[11] <- RSS[11] + 2*Var.FM*GC.ParNum[11]
  Cp[12] <- RSS[12] + 2*Var.FM*GC.ParNum[12]
  
  if(Cp[1]==min(Cp)){res <-1;     y.hat <- res1$pred}@  @     # Cpŏf
  if(Cp[2]==min(Cp)){res <-2;     y.hat <- res2$pred}
  if(Cp[3]==min(Cp)){res <-3;     y.hat <- res3$pred}
  if(Cp[4]==min(Cp)){res <-4;     y.hat <- res4$pred}
  if(Cp[5]==min(Cp)){res <-5;     y.hat <- res5$pred}
  if(Cp[6]==min(Cp)){res <-6;     y.hat <- res6$pred}
  if(Cp[7]==min(Cp)){res <-7;     y.hat <- res7$pred}
  if(Cp[8]==min(Cp)){res <-8;     y.hat <- res8$pred}
  if(Cp[9]==min(Cp)){res <-9;     y.hat <- res9$pred}
  if(Cp[10]==min(Cp)){res <-10;   y.hat <- res10$pred}
  if(Cp[11]==min(Cp)){res <-11;   y.hat <- res11$pred}
  if(Cp[12]==min(Cp)){res <-12;   y.hat <- res12$pred}
       
  list(BestNum=res, Val=min(Cp), All=Cp, RSS.all=RSS, RSS.full=RSS.FM, 
       Predict=y.hat)
  }

IV.cand1.func <- function(num)                          # ľ֐
 {if(num==1){res <- c(100,15,4.35)};    if(num==2){res <- c(100,10,0.5)}
  if(num==3){res <- c(100,0.7,60)};     if(num==4){res <- c(100,2.2,0.3)}
  if(num==5){res <- c(100,0.4)};        if(num==6){res <- c(100,0.1,0.5)}
  if(num==7){res <- c(100,80,1.5,3.1)}; if(num==8){res <- c(100,40,0.5)}
  if(num==9){res <- c(100,11,1.4)};     if(num==10){res <- c(100,0.2,1)}
  if(num==11){res <- c(100,4,10,1)};   if(num==12){res <- c(100,4,0.35,1.1)}
  res 
  }



# XNvgPDW --------------------------------------------------------
GC.CV.func <- function(t,y,iv.func)
 {n <- length(t);   CV <- c(rep(0,12))
  
  for (i in 1:n)                                       # WbNiCt
   {t.j <- t[-i];   y.j <- y[-i]
    beta <- GC.Hos4.est.func(iv.func(1), t.j, y.j)$parameter
     y.hat <- GC.Hos4.func(beta[1], beta[2], beta[3], t)
     CV[1] <- CV[1] + (y[i]-y.hat[i])^2
    beta <- GC.Gom.est.func(iv.func(2), t.j, y.j)$parameter
     y.hat <- GC.Gom.func(beta[1], beta[2], beta[3], t)
     CV[2] <- CV[2] + (y[i]-y.hat[i])^2
    beta <- GC.Log.est.func(iv.func(3), t.j, y.j)$parameter
     y.hat <- GC.Log.func(beta[1], beta[2], beta[3], t)
     CV[3] <- CV[3] + (y[i]-y.hat[i])^2
    beta <- GC.Mon.est.func(iv.func(4), t.j, y.j)$parameter
     y.hat <- GC.Mon.func(beta[1], beta[2], beta[3], t)
     CV[4] <- CV[4] + (y[i]-y.hat[i])^2
    beta <- GC.Ber.est.func(iv.func(5), t.j, y.j)$parameter
     y.hat <- GC.Ber.func(beta[1], beta[2], t)
     CV[5] <- CV[5] + (y[i]-y.hat[i])^2
    beta <- GC.CR.est.func(iv.func(6), t.j, y.j)$parameter
     y.hat <- GC.CR.func(beta[1], beta[2], beta[3], t)
     CV[6] <- CV[6] + (y[i]-y.hat[i])^2
    beta <- GC.Lev1.est.func(iv.func(7), t.j, y.j)$parameter
     y.hat <- GC.Lev1.func(beta[1], beta[2], beta[3], beta[4], t)
     CV[7] <- CV[7] + (y[i]-y.hat[i])^2
    beta <- GC.Lev3.est.func(iv.func(8), t.j, y.j)$parameter
     y.hat <- GC.Lev3.func(beta[1], beta[2], beta[3], t)
     CV[8] <- CV[8] + (y[i]-y.hat[i])^2
    beta <- GC.Kor.est.func(iv.func(9), t.j, y.j)$parameter
     y.hat <- GC.Kor.func(beta[1], beta[2], beta[3], t)
     CV[9] <- CV[9] + (y[i]-y.hat[i])^2
    beta <- GC.Wei.est.func(iv.func(10), t.j, y.j)$parameter
     y.hat <- GC.Wei.func(beta[1], beta[2], beta[3], t)
     CV[10] <- CV[10] + (y[i]-y.hat[i])^2
    beta <- GC.Yos1.est.func(iv.func(11), t.j, y.j)$parameter
     y.hat <- GC.Yos1.func(beta[1], beta[2], beta[3], beta[4], t)
     CV[11] <- CV[11] + (y[i]-y.hat[i])^2
    beta <- GC.Slo.est.func(iv.func(12), t.j, y.j)$parameter
     y.hat <- GC.Slo.func(beta[1], beta[2], beta[3], beta[4], t)
     CV[12] <- CV[12] + (y[i]-y.hat[i])^2
    }
       
  if(CV[1]==min(CV))                                        # CVŏf
   {res <-1;   y.hat <- GC.Hos4.est.func(iv.func(1), t, y)$pred}
  if(CV[2]==min(CV)) 
   {res <-2;   y.hat <- GC.Gom.est.func(iv.func(2), t, y)$pred}
  if(CV[3]==min(CV)) 
   {res <-3;   y.hat <- GC.Log.est.func(iv.func(3), t, y)$pred}
  if(CV[4]==min(CV)) 
   {res <-4;   y.hat <- GC.Mon.est.func(iv.func(4), t, y)$pred}
  if(CV[5]==min(CV)) 
   {res <-5;   y.hat <- GC.Ber.est.func(iv.func(5), t, y)$pred}
  if(CV[6]==min(CV)) 
   {res <-6;   y.hat <- GC.CR.est.func(iv.func(6), t, y)$pred}
  if(CV[7]==min(CV)) 
   {res <-7;   y.hat <- GC.Lev1.est.func(iv.func(7), t, y)$pred}
  if(CV[8]==min(CV)) 
   {res <-8;   y.hat <- GC.Lev3.est.func(iv.func(8), t, y)$pred}
  if(CV[9]==min(CV)) 
   {res <-9;   y.hat <- GC.Kor.est.func(iv.func(9), t, y)$pred}
  if(CV[10]==min(CV)) 
   {res <-10;   y.hat <- GC.Wei.est.func(iv.func(10), t, y)$pred}
  if(CV[11]==min(CV)) 
   {res <-11;   y.hat <- GC.Yos1.est.func(iv.func(11), t, y)$pred}
  if(CV[12]==min(CV)) 
   {res <-12;   y.hat <- GC.Slo.est.func(iv.func(12), t, y)$pred}
  
  list(BestNum=res, Val=min(CV), All=CV, Predict=y.hat)
  }



# XNvgPDX --------------------------------------------------------
GC.AIC.func <- function(t,y,iv.func)
 {n <- length(t)
  res1 <- GC.Hos4.est.func(iv.func(1), t, y)   # Hossfeld-4ɂ铖Ă͂
  res2 <- GC.Gom.est.func(iv.func(2), t, y)    # Gompertzɂ铖Ă͂
  res3 <- GC.Log.est.func(iv.func(3), t, y)    # Logisticɂ铖Ă͂
  res4 <- GC.Mon.est.func(iv.func(4), t, y)    # Monomolecularɂ铖Ă͂
  res5 <- GC.Ber.est.func(iv.func(5), t, y)    # Bertlanffyɂ铖Ă͂
  res6 <- GC.CR.est.func(iv.func(6), t, y)     # Chapman-Richardsɂ铖Ă͂
  res7 <- GC.Lev1.est.func(iv.func(7), t, y)   # Levacovic-1ɂ铖Ă͂
  res8 <- GC.Lev3.est.func(iv.func(8), t, y)   # Levacovic-3ɂ铖Ă͂
  res9 <- GC.Kor.est.func(iv.func(9), t, y)    # Korfɂ铖Ă͂
  res10 <- GC.Wei.est.func(iv.func(10), t, y)  # Weibullɂ铖Ă͂
  res11 <- GC.Yos1.est.func(iv.func(11), t, y) # Yoshida-1ɂ铖Ă͂
  res12 <- GC.Slo.est.func(iv.func(12), t, y)  # Slobodaɂ铖Ă͂
  
  RSS <- Var <- c(1:12)                                         # ca
  RSS[1] <- res1$RSS;     RSS[2] <- res2$RSS;     RSS[3] <- res3$RSS
  RSS[4] <- res4$RSS;     RSS[5] <- res5$RSS;     RSS[6] <- res6$RSS
  RSS[7] <- res7$RSS;     RSS[8] <- res8$RSS;     RSS[9] <- res9$RSS
  RSS[10] <- res10$RSS;   RSS[11] <- res11$RSS;   RSS[12] <- res12$RSS
  
  AIC <- c(1:12)                                                 # AIC̎Zo
  AIC[1] <- n*(log(2*pi)+log(RSS[1]/n)+1)+2*GC.ParNum[1]
  AIC[2] <- n*(log(2*pi)+log(RSS[2]/n)+1)+2*GC.ParNum[2]
  AIC[3] <- n*(log(2*pi)+log(RSS[3]/n)+1)+2*GC.ParNum[3]
  AIC[4] <- n*(log(2*pi)+log(RSS[4]/n)+1)+2*GC.ParNum[4]
  AIC[5] <- n*(log(2*pi)+log(RSS[5]/n)+1)+2*GC.ParNum[5]
  AIC[6] <- n*(log(2*pi)+log(RSS[6]/n)+1)+2*GC.ParNum[6]
  AIC[7] <- n*(log(2*pi)+log(RSS[7]/n)+1)+2*GC.ParNum[7]
  AIC[8] <- n*(log(2*pi)+log(RSS[8]/n)+1)+2*GC.ParNum[8]
  AIC[9] <- n*(log(2*pi)+log(RSS[9]/n)+1)+2*GC.ParNum[9]
  AIC[10] <- n*(log(2*pi)+log(RSS[10]/n)+1)+2*GC.ParNum[10]
  AIC[11] <- n*(log(2*pi)+log(RSS[11]/n)+1)+2*GC.ParNum[11]
  AIC[12] <- n*(log(2*pi)+log(RSS[12]/n)+1)+2*GC.ParNum[12]
  
  if(AIC[1]==min(AIC)){res <-1;   y.hat <- res1$pred}        # AICŏf
  if(AIC[2]==min(AIC)){res <-2;   y.hat <- res2$pred}
  if(AIC[3]==min(AIC)){res <-3;   y.hat <- res3$pred}
  if(AIC[4]==min(AIC)){res <-4;   y.hat <- res4$pred}
  if(AIC[5]==min(AIC)){res <-5;   y.hat <- res5$pred}
  if(AIC[6]==min(AIC)){res <-6;   y.hat <- res6$pred}
  if(AIC[7]==min(AIC)){res <-7;   y.hat <- res7$pred}
  if(AIC[8]==min(AIC)){res <-8;   y.hat <- res8$pred}
  if(AIC[9]==min(AIC)){res <-9;   y.hat <- res9$pred}
  if(AIC[10]==min(AIC)){res <-10;   y.hat <- res10$pred}
  if(AIC[11]==min(AIC)){res <-11;   y.hat <- res11$pred}
  if(AIC[12]==min(AIC)){res <-12;   y.hat <- res12$pred}
  list(BestNum=res, Val=min(AIC), All=AIC, Predict=y.hat)
  }



# XNvgPDPO ------------------------------------------------------
source("Kankyo.R")
t <- c(0:90)/6
plot(t, GC.Ber.func(100,0.45,t), type="l", xlab="", ylab="")



# XNvgPDPP ------------------------------------------------------
source("Kankyo.R")
set.seed(1)                                              # ̃V[hݒ
t <- c(3:32)/2
mu <- GC.Ber.func(100,0.45,t)                                      # Ғl
e <- rnorm(length(t), mean=0, sd=sqrt(10))                         # 덷
y <- mu + e                                                        # ϑl



# XNvgPDPQ ------------------------------------------------------
source("Kankyo.R")
t <- c(0:90)/6
mu <- GC.Ber.func(100,0.45,t)
plot(t, mu, type="l", xlab="", ylab="")
set.seed(1)
t2 <- c(3:32)/2
mu <- GC.Ber.func(100,0.45,t2)                                      # Ғl
e <- rnorm(length(t2), mean=0, sd=sqrt(10))                         # 덷
y <- mu + e                                                         # ϑl
points(t2, y)



# XNvgPDPR ------------------------------------------------------
source("Kankyo.R")
GC.Hos4.est.func(c(100,15,4.35), t2, y)$RSS



# XNvgPDPS ------------------------------------------------------
source("Kankyo.R")
GC.Cp.func(t2, y, IV.cand1.func)



# XNvgPDPT ------------------------------------------------------
source("Kankyo.R")
Res.Cp <- c(31,33,7,24,795,31,0,28,5,42,4,0)              # \1.5̌ʂ
barplot(Res.Cp, names.arg=GC.name[1:12], las=2, ylim=c(0,1000))



# XNvgPDPU ------------------------------------------------------
source("Kankyo.R")
set.seed(1)
t <- c(3:32)/2
mu <- GC.Ber.func(100,0.45,t)
CV <- NULL
for (i in 1:1000)
 {e <- rnorm(length(t), mean=0, sd=sqrt(10));   y <- mu + e
  CV <- rbind(CV, GC.CV.func(t, y, IV.cand1.func)$All)
  }



# XNvgPDPV ------------------------------------------------------
source("Kankyo.R")
Data <- read.csv("Hoshino_Growth.csv", header=T)         # f[^̓ǂݍ
Age <- Data[Data$ID==HoshinoID[1],]$Age                  # ї
DBH <- Data[Data$ID==HoshinoID[1],]$DBH                  # a
plot(Age, DBH, ylim=c(0,max(Data$DBH)), type="o", xlab="їiNj", 
     ylab="aicmj")
for(i in 2:length(HoshinoID)) 
 {Age <- Data[Data$ID==HoshinoID[i],]$Age
  DBH <- Data[Data$ID==HoshinoID[i],]$DBH
  points(Age, DBH, type="o")
  }



# XNvgPDPW ------------------------------------------------------
source("Kankyo.R")
Data <- read.csv("Hoshino_Growth.csv", header=T)
Res <- matrix(0, length(HoshinoID), 3)
for(i in 1:length(HoshinoID))
 {Age <- Data[Data$ID==HoshinoID[i],]$Age
  DBH <- Data[Data$ID==HoshinoID[i],]$DBH
  Res[i,1] <- GC.Cp.func(Age,DBH,IV.cand3.func)$BestNum              # Cp
  Res[i,2] <- GC.AIC.func(Age,DBH,IV.cand3.func)$BestNum             # AIC
  Res[i,3] <- GC.CV.func(Age,DBH,IV.cand3.func)$BestNum              # CV
  }



# XNvgQDP --------------------------------------------------------
par.sdmd <- c(0.068509, 1.347565, 2658.2, 2.814651, 0.791213, 0.244012,
          0.353895, 0.048940, 0.034814, 0.98937, 3470890, 0.9184, 0.05, 1)


# XNvgQDQ --------------------------------------------------------
source("Kankyo.R")
F <- read.csv("Hoshino_Growth.csv", header=T)
H.nls <- nls(Height~a*exp(-b*Age^{-c}), data=F, start=c(a=30,b=1,c=1),
             control=list(maxint=10000))
Age <- F[F$ID==HoshinoID[1],]$Age
Height <- F[F$ID==HoshinoID[1],]$Height
plot(Age, Height, ylim=c(0,max(F$Height)), type="l", lty=2,
     xlab="їiNj", ylab="imj")
for(i in 2:length(HoshinoID))
 {Age <- F[F$ID==HoshinoID[i],]$Age
  Height <- F[F$ID==HoshinoID[i],]$Height
  points(Age, Height, type="l", lty=2)
  }
a <- coef(H.nls)[1];   b <- coef(H.nls)[2];   c <- coef(H.nls)[3]
lines(sort(unique(F$Age)), a*exp(-b*sort(unique(F$Age))^{-c}), lwd=3)



# XNvgQDR --------------------------------------------------------
growth.sdmd.func <- function(p, time, N0)
 {N <- c(rep(2918,length(time)))                                 # ؖ{
  H1 <- exp(p[13])*exp(-exp(p[14])*time^(-exp(p[15])))
  v1 <- 1/(exp(p[1])*N*H1^(-exp(p[2]))+exp(p[3])*H1^(-exp(p[4]))) # (2.1)
  V <- v1*N                                                       # (2.2)
  HF <- exp(p[5])+exp(p[6])*H1*sqrt(N)/100+exp(p[7])*H1           # (2.3)
  G <- V/HF                                                       # (2.4)
  Dg <- 200*sqrt(G/(pi*N))                                        # (2.5)
  D1 <- -exp(p[8])-exp(p[9])*H1*sqrt(N)/100 + exp(p[10])*Dg       # (2.6)
  N1 <- (1/N0 + v1/(exp(p[11])*N0^(-exp(p[12]))))^(-1)            # (2.7)
  cbind(time, H1, D1, N1, v1)
  }



# XNvgQDS --------------------------------------------------------
p0 <- log(par.sdmd);   p0[13:15] <- log(coef(H.nls))
growth <- data.frame(growth.sdmd.func(p0, F$Age, 3000)) # Growth Prediction

# 
plot(F[F$ID==HoshinoID[1],]$Age, F[F$ID==HoshinoID[1],]$Height, 
     ylim=c(0,max(F$Height)), type="l", lty=2, lwd=0.5, xlab="їiNj",
     ylab="imj")
for(i in 2:length(HoshinoID))
 {points(F[F$ID==HoshinoID[i],]$Age, F[F$ID==HoshinoID[i],]$Height, type="l",
  lty=2, lwd=0.5)
  }
lines(sort(unique(growth$t)), sort(unique(growth$H1)), lwd=5)

# a
plot(F[F$ID==HoshinoID[1],]$Age, F[F$ID==HoshinoID[1],]$DBH, 
     ylim=c(0,max(F$DBH)), type="l", lty=2, lwd=0.5, xlab="ї (N)",
     ylab="a (cm)")
for(i in 2:length(HoshinoID)) 
 {points(F[F$ID==HoshinoID[i],]$Age, F[F$ID==HoshinoID[i],]$DBH, type="l",
         lty=2, lwd=0.5)
  }
lines(sort(unique(growth$t)), sort(unique(growth$D1)), lwd=5)

# ސ
plot(F[F$ID==HoshinoID[1],]$Age, F[F$ID==HoshinoID[1],]$Z, 
     ylim=c(0,max(F$Z)), type="l", lty=2, lwd=0.5, xlab="ї (N)", 
     ylab=bquote('ސ (m'^'3'*')'))
for(i in 2:length(HoshinoID)) 
 {points(F[F$ID==HoshinoID[i],]$Age, F[F$ID==HoshinoID[i],]$Z, type="l", 
         lty=2, lwd=0.5)
  }
lines(sort(unique(growth$t)), sort(unique(growth$v1)), lwd=5)



# XNvgQDT --------------------------------------------------------
FS.sdmd.func <- function(p, t, D, H, v, N0)
 {N <- 1:length(t);   N[]<-N0
  dif <- matrix(0, length(t), 4)
  H1 <- exp(p[13])*exp(-exp(p[14])*t^(-exp(p[15])))
  dif[,1] <- H1 - H
  v1 <- 1/(exp(p[1])*N*H1^(-exp(p[2]))+exp(p[3])*H1^(-exp(p[4]))) # (2.1)
  dif[,2] <- v1-v
  V <- v1*N                                                       # (2.2)
  HF <- exp(p[5])+exp(p[6])*H1*sqrt(N)/100+exp(p[7])*H1           # (2.3)
  G <- (V/HF)                                                     # (2.4)
  Dg <- 200*sqrt((G/(pi*N)))                                      # (2.5)
  D1 <- -exp(p[8])-exp(p[9])*H1*sqrt(N)/100+exp(p[10])*Dg         # (2.6)
  dif[,3] <- D1-D
  sum(dif^2)                                                     # (2.11)
  }



# XNvgQDU --------------------------------------------------------
SD.sdmd.func <- function(p, t, D, H, v, N0)
 {N <- 1:length(t);   N[]<- N0
  dif <- matrix(0, length(t), 3)
  H1 <- exp(p[13])*exp(-exp(p[14])*t^(-exp(p[15])))
  dif[,1] <- H1-H
  v1 <- 1/(exp(p[1])*N*H1^(-exp(p[2]))+exp(p[3])*H1^(-exp(p[4]))) # (2.1)
  dif[,2] <- v1-v
  V <- v1*N                                                       # (2.2)
  HF <- exp(p[5])+exp(p[6])*H1*sqrt(N)/100+exp(p[7])*H1           # (2.3)
  G <- (V/HF)                                                     # (2.4)
  Dg <- 200*sqrt((G/(pi*N)))                                      # (2.5)
  D1 <- -exp(p[8])-exp(p[9])*H1*sqrt(N)/100+exp(p[10])*Dg         # (2.6)
  dif[,3] <- D1-D
  sigma <- matrix(0, 3, 3)
  for(i in 1:length(H1)) {sigma<-sigma+dif[i,]%*%t(dif[i,])}
  sigma <- sigma/length(t)                                       # (2.12)
  SD <- c(0)
  for(i in 1:length(t)){SD <- SD+t(dif[i,])%*%solve(sigma)%*%dif[i,]}
  SD                                                             # (2.13)
  }



# XNvgQDV --------------------------------------------------------
source("Kankyo.R")
# First step for generalized least square estimation
FS.glse <- nlminb(p0, FS.sdmd.func, t=F[,2],D=F[,3],H=F[,4],v=F[,5],
                  N0=3100, control=list(eval.max=10000,iter.max=10000))
p0 <- FS.glse$par
# Second step for generalized least square estimation
SD.glse <- nlminb(p0, SD.sdmd.func, t=F[,2],D=F[,3],H=F[,4],v=F[,5],
                  N0=3100, control=list(eval.max=10000,iter.max=10000))
p <- SD.glse$par



# XNvgRDP --------------------------------------------------------
Y <- as.matrix(read.csv("sec3data.csv", header=FALSE))[,-1]
t <- as.matrix(c(7:23), ncol=1)
t2 <- t-12;   t2 <- t2[-6]
plot(t, Y[1,], type="b", xlim=c(5,25), ylim=c(0,40), xlab="їiNj", 
     ylab="a(cm)")
for(i in 2:52){points(t, Y[i,], type="b")}
for(i in 53:82){points(t, Y[i,], type="b", pch=2, lty=2)}
legend("topleft", c("KԔ","Ԕ"), pch=c(1,2), lty=c(1,2), inset = .05)



# XNvgRDQ --------------------------------------------------------
Est1.GMANOVA.func <- function(A, X, Y)                         # ̐
 {n <- dim(Y)[1];   k <- dim(A)[2]
  Pa <- A%*%solve(t(A)%*%A)%*%t(A);   In <- diag(1,n)  # ˉesƒPʍs
  S <- t(Y)%*%(In-Pa)%*%Y/(n-k)
  solve(t(A)%*%A)%*%t(A)%*%Y%*%solve(S)%*%X%*%solve(t(X)%*%solve(S)%*%X)
  }
  
Est2.GMANOVA.func <- function(A, X, Y)                         # ̐
 {n <- dim(Y)[1];   k <- dim(A)[2]
  Pa <- A%*%solve(t(A)%*%A)%*%t(A);   In <- diag(1,n)
  S <- t(Y)%*%(In-Pa)%*%Y / (n-k)
  xi <- Est1.GMANOVA.func(A,X,Y)
  t(Y-A%*%xi%*%t(X))%*%(Y-A%*%xi%*%t(X))/n
  }



# XNvgRDR --------------------------------------------------------
source("Kankyo.R")
A <- matrix(c(rep(c(1,0),52),rep(c(0,1),30)), byrow=TRUE, ncol=2)
X <- as.matrix(cbind(matrix(1,17,1),t,t^2))
X2 <- as.matrix(cbind(t2,t2^2))
xi <- Est1.GMANOVA.func(A,X,Y)                     
sigma <- Est2.GMANOVA.func(A,X,Y)                   
Yhat <- A%*%xi%*%t(X)



# XNvgRDS --------------------------------------------------------
Tst.GMANOVA.func <- function(A,X,Y,C,D)
 {n <- dim(Y)[1];   p <- dim(Y)[2];   k <- dim(A)[2];   q <- dim(X)[2]
  c <- qr(C)$rank;   d <- qr(D)$rank
  Pa <- A%*%solve(t(A)%*%A)%*%t(A);   In <- diag(1,n)
  S <- t(Y)%*%(In-Pa)%*%Y
  R <- solve(S)-solve(S)%*%X%*%solve(t(X)%*%solve(S)%*%X)%*%t(X)%*%solve(S)
  R <- solve(t(A)%*%A)%*%t(A)%*%Y%*%R%*%t(Y)%*%A%*%solve(t(A)%*%A)
  R <- (solve(t(A)%*%A)+R)/(n-k)                                 # (3.30)
  xi <- Est1.GMANOVA.func(A,X,Y)                                 # (3.16)
  Se <- (n-k)*t(D)%*%solve(t(X)%*%solve(S)%*%X)%*%D              # (3.28)
  Sh <- t(C%*%xi%*%D)%*%solve(C%*%R%*%t(C))%*%C%*%xi%*%D         # (3.29)
  Lamda <- det(Se)/det(Se+Sh)
  -(n-k-(p-q)-(d-c+1)/2)*log(Lamda)                              # (3.27)
  }



# XNvgRDT --------------------------------------------------------
source("Kankyo.R")
C <- matrix(c(1,-1), byrow=TRUE, ncol=2)
Tst.GMANOVA.func(A, X, Y, C, diag(1,3))



# XNvgRDU --------------------------------------------------------
source("Kankyo.R")
Y2 <- Y-Y[,6];   Y2 <- Y2[,-6]
E1 <- Est1.GMANOVA.func(A, X2, Y2);   E2 <- Est2.GMANOVA.func(A, X2, Y2)
Y2hat <- A%*%E1%*%t(X2)
plot(t2, Y2[1,], type="b", xlim=c(-5,12), ylim=c(-15,20), 
     xlab="їiNj", ylab="a(cm)")
for (i in 2:52) {points(t2,Y2[i,],type="b")}
points(t2, Y2hat[1,], type="l", lwd=5)
legend("topleft", c("l","KԔf[^"), lty=c(1,1), lwd=c(5,1), 
       pch=c(NA, 1), inset = .05, bty="n")



# XNvgSDP --------------------------------------------------------
Theta.func <- function(X, Y) {solve(t(X)%*%X)%*%t(X)%*%Y}      # ̐
Sigma.func <- function(X, Y)                                   # ̐
 {n <- dim(X)[1];   In <- diag(1,n);   Px <- X%*%solve(t(X)%*%X)%*%t(X)
  (1/n)*t(Y)%*%(In-Px)%*%Y 
  }



# XNvgSDQ --------------------------------------------------------
CV1.func <- function(X, Y)
 {n <- dim(Y)[1];   p <- dim(Y)[2];   k <- dim(X)[2]
  temp <- 0
  for(i in 1:n)                                        # WbNiCt
   {xi <- as.matrix(X[i,], ncol=1);   yi <- as.matrix(Y[i,], ncol=1)
    Xi <- X[-i,];   Yi <- Y[-i,]
    Theta <- Theta.func(Xi,Yi);   Sigma <- Sigma.func(Xi,Yi)
    temp <- temp+log(det(Sigma))
    temp <- temp+t(yi-t(Theta)%*%xi)%*%solve(Sigma)%*%(yi-t(Theta)%*%xi)
    }
  n*p*log(2*pi)+temp
  }



# XNvgSDR --------------------------------------------------------
GC.expCR.func <- function(a, b, c, t){exp(a)*(1-exp(-exp(b)*t))^exp(c)}



# XNvgSDS --------------------------------------------------------
source("Kankyo.R")
F <- read.csv("Hoshino_Growth.csv")
tp <- c(23.89,0.064,1.8)          # initial values of parameters for height
D1 <- D2 <- matrix(0,length(HoshinoID),3)
for(j in 1:(length(HoshinoID)))
 {x <- F$Age[F$ID==HoshinoID[j]]
  y1 <- F$DBH[F$ID==HoshinoID[j]];   y2 <- F$Height[F$ID==HoshinoID[j]]
  da1 <- data.frame(x,y1);   da2 <- data.frame(x,y2)
  RSS1.func <- function(b) 
   {temp <- y1-GC.expCR.func(b[1], b[2], b[3], x);  t(temp)%*%temp}
  RSS2.func <- function(b)
   {temp <- y2-GC.expCR.func(b[1], b[2], b[3], x);   t(temp)%*%temp}
  opt1 <- optim(c(log(tp[1]),log(tp[2]),log(tp[3])),
                RSS1.func, control=list(maxit=10000))
  opt2 <- optim(c(log(tp[1]),log(tp[2]),log(tp[3])),
                RSS2.func, control=list(maxit=10000))
  D1[j,] <- c(opt1$par);   D2[j,] <- c(opt2$par)
  }
D <- cbind(HoshinoID, D1, D2)



# XNvgSDT --------------------------------------------------------
AIC.func <- function(X,Y)
 {n <- dim(Y)[1];   p <- dim(Y)[2];   k <- dim(X)[2]
  Theta <- Theta.func(X,Y)                                      
  Sigma <- Sigma.func(X,Y)                                     
  n*p*(log(2*pi)+1) + n*log(det(Sigma))+2*(p*k+p*(p+1)/2)
  }



# XNvgSDU --------------------------------------------------------
source("Kankyo.R")
G <- read.csv("Hoshino_Expl.csv", header=T)
Y <- as.matrix(D[,-1]);   Y1 <- Y[,1:3];   Y2 <- Y[,4:6]
X0 <- as.matrix(G);   X0[,1] <- 1
cand <- 2^(dim(X0)[2]-1)-1;   Res1 <- Res2 <- NULL
for(iter in 1:cand)                             
 {X <- X.cand.func(iter, X0[,-1])
  AIC1 <- AIC.func(X,Y1);   AIC2 <- AIC.func(X,Y2)
  CV1 <- CV1.func(X,Y1);    CV2 <- CV1.func(X,Y2)
  Res1 <- rbind(Res1, c(dim(X)[2], var.vec.func(iter,X0[,-1]), AIC1, CV1))
  Res2 <- rbind(Res2, c(dim(X)[2], var.vec.func(iter,X0[,-1]), AIC2, CV2))
  }

Res1 <- data.frame(Res1);   Res2 <- data.frame(Res2)
names(Res1) <- names(Res2) <- c("Num of Var", names(G)[-1], "AIC", "CV")

best.aic1 <- Res1[Res1$AIC==min(Res1$AIC),]                
best.aic2 <- Res2[Res2$AIC==min(Res2$AIC),]               
best.cv1 <- Res1[Res1$CV==min(Res1$CV),]                  
best.cv2 <- Res2[Res2$CV==min(Res2$CV),]                 



# XNvgSDV --------------------------------------------------------
GCD.func <- function(X,Y)
 {Px <- X %*% solve(t(X)%*%X) %*% t(X)                           # ˉes
  Py <- Y %*% solve(t(Y)%*%Y) %*% t(Y)
  sum(diag(Px%*%Py)) / qr(t(X)%*%Y)$rank
  }



# XNvgSDW --------------------------------------------------------
source("Kankyo.R")
temp <- best.aic1[2:13];   best.aic1.X <- X0[,1]
for(i in 1:length(temp)) 
 {if (temp[i]==1) {best.aic1.X <- cbind(best.aic1.X, X0[,(i+1)])}}
GCD.func(best.aic1.X, Y1)



# XNvgSDX --------------------------------------------------------
qqnorm(D[,2])
qqline(D[,2], lwd=2)



# XNvgSDPO ------------------------------------------------------
source("Kankyo.R")  

best.cv1.X <- best.cv2.X <- X[,1]
for(i in 2:13)
 {if (best.cv1[i]==1) {best.cv1.X <- cbind(best.cv1.X, X[,i])}
  if (best.cv2[i]==1) {best.cv2.X <- cbind(best.cv2.X, X[,i])}
  }

Th1 <- Theta.func(best.cv1.X, Y[,1:3])
Si1 <- Sigma.func(best.cv1.X, Y[,1:3])
Th2 <- Theta.func(best.cv2.X, Y[,4:6])
Si2 <- Sigma.func(best.cv2.X, Y[,4:6])
rho1 <- rho2 <- matrix(0,3,3)
for(i in 1:3)
for(j in 1:3)
 {rho1[i,j] <- Si1[i,j] / sqrt(Si1[i,i]*Si1[j,j])
  rho2[i,j] <- Si2[i,j] / sqrt(Si2[i,i]*Si2[j,j])
  }



# XNvgSDPP ------------------------------------------------------
t <- c(1:80)
wDBH5.c <- DBH0.c <- c(10+2*c(0:5), 15)
X.DBH <- matrix(1,49,3);   X.H <- matrix(1,49,4)
n <- 1
for(i in 1:7)
for(j in 1:7)
 {X.DBH[n,2] <- X.H[n,3] <- DBH0.c[i]
  X.DBH[n,3] <- X.H[n,4] <- wDBH5.c[j]
  X.H[n,2] <- mean(X0[,2])
  n <- n+1
  }
T.DBH <- X.DBH%*%Th1;   T.H <- X.H%*%Th2
DBH.est <- H.est <- NULL
for(i in 1:49)
 {DBH.est <- rbind(DBH.est, 
                   GC.expCR.func(T.DBH[i,1], T.DBH[i,2], T.DBH[i,3], t))
  H.est <- rbind(H.est, GC.expCR.func(T.H[i,1], T.H[i,2], T.H[i,3], t))
  }
DBH.est <- cbind(X.DBH[,2:3], DBH.est);   H.est <- cbind(X.H[,3:4], H.est)
  
max <- max(max(DBH.est[,-1:-2]), max(H.est[,-1:-2]))
Data.DBH <- DBH.est[DBH.est[,1]==10,]
plot(t, Data.DBH[1,-1:-2], type="l", ylim=c(0,max), main="DBH0 = 10",
     xlab="їiNj", ylab="aicmj")
for(k in 2:6){points(t, Data.DBH[k,-1:-2], type="l", lty=k)}



# XNvgSDPQ ------------------------------------------------------
CV2.func <- function(X,Y)
 {n <- dim(Y)[1];   p <- dim(Y)[2];   k <- dim(X)[2]
  Theta <- Theta.func(X,Y)
  Sigma <- Sigma.func(X,Y)
  temp <- 0
  for(i in 1:n)
   {xi <- as.matrix(X[i,], ncol=1);   yi <- as.matrix(Y[i,], ncol=1)
    hi <- 1-t(xi)%*%solve(t(X)%*%X)%*%xi
    ri2 <- t(yi-t(Theta)%*%xi)%*%solve(Sigma)%*%(yi-t(Theta)%*%xi)
    temp <- temp+log(1-(ri2/(n*hi)))+((n-1)*ri2)/(hi*(n*hi-ri2))
    }
  n*p*log(2*pi*n/(n-1))+n*log(det(Sigma))+temp
  }



# XNvgSDPR ------------------------------------------------------
nishin.func <- function(n)                         # POi@˂Qi@̊֐
 {temp <- n;   res <- 0;   k <- 0
  while(temp>=1) 
   {res <- res+temp%%2*10^k;   k <- k+1;   temp <- temp %/% 2 }
  res
  }

X.cand.func <- function(N, X.full)                 # ϐs̍쐬֐
 {n <- dim(X.full)[1];   temp <- nishin.func(N);   i <- 0;   X <- NULL
  while(temp>=1) 
   {if(temp%%10==1){X <- cbind(X.full[,dim(X.full)[2]-i], X)} 
    temp <- temp%/%10;   i <- i+1
    }
  cbind(c(rep(1,n)), X)
  }

var.vec.func <- function(N, X.full)
 {n <- dim(X.full)[1];   p <- dim(X.full)[2];   temp <- nishin.func(N);   i <- 0
  variable <- c(rep(0,p));   var.num <- 0
  while (temp>=1)
   {if (temp%%10==1) {variable[p-i] <- 1;   var.num <- var.num+1}
    temp <- temp%/%10;   i <- i+1
    }
  variable
  }



# XNvgTDP --------------------------------------------------------
# k-means Cluster analysis
# RES<-KCLUS(Y,km,itm,nm,Clus)
# RES(k,1:n): k̃NX^[̂Ƃ̃NX^[
#
#   Y:n~p f[^s,  km:őNX^[,  itm:őJԂ
#           nm:ŏNX^[W{,  clus:œK@(1 g[X, 2 s)

KCLUS <- function(Y, km, itm, nm, clus)
 {n <- length(Y[,1]);   p <- length(Y[1,]);   RES <- matrix(0,km,n)
  RES0 <- RES;   CV <- RES;   DD <- CV;   D <- DD;   k <- 1
  RES[k,] <- 1
  for(k in 2:km)
   {print(paste(k,"̃NX^[̍œK"))
    RES0 <- rep(0,n);   CV <- t(c(1:k));   it <- 1;   itIND <- 1;
    INF0IND <- 0
    while(itIND==1)
     {DpIND <- 1;
      while(DpIND==1)
       {DIND <- round(runif(n,1,k))
        D <- matrix(0,n,k)
        for(i in 1:n){D[i,DIND[i]] <- 1}
        NM <- colSums(D);
        DpIND <- 0;
        for(j in 1:k){if (NM[j]<=nm) {DpIND <- 1}}
        }
      CIND <- 1;
      W <- t(Y)%*%(diag(n)-D%*%solve(t(D)%*%D)%*%t(D))%*%Y
      M <- solve(t(D)%*%D)%*%t(D)%*%Y
      while(CIND==1)
       {DD <- D;   i <- 1;   NIND <- 1
        while(NIND==1)
         {JIND <- matrix(0,k,1);   d0 <- D[i,];   n0 <- t(d0) %*% NM
          M0 <- t(M) %*% d0;   a0 <- Y[i,] - M0
          for(j in 1:k)
           {n1 <- NM[j];   M1 <- (M[j,]);   a1 <- (Y[i,])-M1
            if(clus==1)
             {JIND[j] <- (n1/(n1+1))*t(a1)%*%a1-(n0/(n0-1))*t(a0)%*%a0}
            else
             {JIND[j] <- 1+(n1/(n1+1))*t(a1)%*%solve(W)%*%a1
              JIND[j] <- JIND[j] * (1-(n0/(n0-1))*t(a0)%*%solve(W)%*%a0)
              temp <- (t(a1)%*%solve(W)%*%a0)^2
              JIND[j] <- JIND[j] + (n0/(n0-1))*(n1/(n1+1))*temp
              }
            }
          MJIND <- min(JIND)
          RJIND <- rank(JIND)
          for(j in 1:k){if(RJIND[j]==1){MIND <- j}}
          D[i,] <- matrix(0,1,k)
          D[i,MIND] <- 1
          W <- t(Y)%*%(diag(n)-D%*%solve(t(D)%*%D)%*%t(D))%*%Y
          M <- solve(t(D)%*%D)%*%t(D)%*%Y
          NM <- colSums(D)
          i <- i+1
          for(j in 1:k)
           {if (NM[j]<=nm) {NIND <- 0;   CIND <- 0;   INF0IND <- 1}}
          if(i>n){NIND <- 0}
          }
        DDY <- sum(diag(t(DD)%*%D))
        if(DDY == n){CIND <- 0}
      }
      RES1 <- rep(0,n+1)
      RES1[1:n] <- CV%*%t(D)
      if(clus==1){DDX <- sum(diag(t(W)%*%W));   RES1[n+1] <- DDX}
      else {RES1[n+1] <- det(W)}
      if(it==1)
       {RES0 <- RES1
        if(INF0IND !=1)
         {if(clus==1)
           {print(paste(it,"Ԗڂ̍œK tr(W)=",RES0[n+1]))}
          else{print(paste(it,"Ԗڂ̍œK det(W)=",RES0[n+1]))}
          }
        }
      if(RES0[n+1]>RES1[n+1])
       {RES0 <- RES1
        if(clus==1) 
         {print(paste(it,"Ԗڂ̍œK tr(W)=",RES0[n+1]))}
        else{print(paste(it,"Ԗڂ̍œK det(W)=",RES0[n+1]))}
        }
      it <- it+1
      if(INF0IND==1){it <- it-1}
      INF0IND <- 0;
      if(it>itm){itIND <- 0}
      }
    RES[k,] <- RES0[1:n]
    }
  return(RES)
  }

source("Kankyo.R")
RES <- KCLUS(Y.sec5, 4, 100, 6, 2)



# XNvgTDQ --------------------------------------------------------
# NX^[̌
source("Kankyo.R")
km <- 4;   n <- 30;   p <- 3
AIC <- CAIC <- rep(0,km)
for(k in 1:km)
 {D <- matrix(0,n,k)
  YE <- cbind(Y.sec5,RES[k,])
  for(i in 1:n){D[i,RES[k,i]] <- 1}
  logS1 <- 0;   c1 <- 0;
  for(j in 1:k)
   {Y1 <- matrix(YE[,1:3][YE[,4]==j],ncol=3)
    n1 <- length(Y1[,1])
    S1 <- t(Y1)%*%(diag(n1)-matrix(1,n1,n1)/n1)%*%Y1/n1
    logS1 <- logS1+n1*log(det(S1))
    c1 <- c1+n1*(n1+1)*p/(n1-p-2)
    }
  AIC[k] <- logS1+n*p*(log(2*pi)+1)+k*p*(p+3)
  CAIC[k] <- logS1+n*p*log(2*pi)+c1
  }



# XNvgUDP --------------------------------------------------------
source("Kankyo.R")
require(nlme)
F <- read.csv("Hoshino_Growth.csv")
colnames(F) <- c("ID", "Age", "DBH", "Height", "Vol")

x <- F$Age; y <- F$DBH                                         # DBH Growth
RSS.6.f <- function(b) 
 {temp <- y-GC.expCR.func(b[1], b[2], b[3], x);   t(temp)%*%temp }
opt <- optim(c(0,0,0), RSS.6.f, control=list(maxit=10000))
beta.6 <- opt$par
DBHnlme <- nlme(DBH ~ GC.expCR.func(a,b,c,Age), data=F, 
                fixed = a+b+c ~1, random = a+b+c ~ 1, groups = ~ID,
                start=c(a=beta.6[1],b=beta.6[2],c=beta.6[3]), 
                control=list(maxIter=10000))



# XNvgUDQ --------------------------------------------------------
#iMԎZoFaȐ̏ꍇj
DBHPhi <- cov(coef(DBHnlme))
DBHsigma2 <- var(residuals(DBHnlme))
f <- function(a,b,c,t){(exp(a)*(1-exp(-exp(b)*t))^exp(c))}
f1 <- function(a,b,c,t){(exp(a)*(1-exp(-exp(b)*t))^exp(c))}
f2 <- function(a,b,c,t) 
 {(exp(a)*(1-exp(-exp(b)*t))^exp(c))*(exp(b+c-exp(b)*t)/(1-exp(-exp(b)*t)))}
f3 <- function(a,b,c,t)
 {(exp(a)*(1-exp(-exp(b)*t))^exp(c))*(exp(c)*log(1-exp(-exp(b)*t)))}
ID <- unique(F$ID)
n <- length(ID)
a <- fixef(DBHnlme)[1];   b <- fixef(DBHnlme)[2];   c <- fixef(DBHnlme)[3]
sum <- matrix(0,3,3)
for(i in 1:n)
 {x <- F$Age[F$ID==ID[i]]
  Z <- matrix(0,length(x),3)
  Z <- cbind(f1(a,b,c,x),f2(a,b,c,x),f3(a,b,c,x))
  Sigma <- diag(DBHsigma2,length(x),length(x))+Z %*% DBHPhi %*% t(Z)
  sum <- sum + t(Z) %*% solve(Sigma) %*% Z
  }
sum <- sum/n
Ohme <- solve(sum)

t <- seq(1,30,1)                    # 95% Confidence interval upto 30 years
zmean <- C_low <- C_up <- t
for(i in 1:30)
 {z <- c(f1(a,b,c,t[i]), f2(a,b,c,t[i]), f3(a,b,c,t[i]))
  C_low[i] <- f(a,b,c,t[i])-sqrt(1/n*(t(z)%*%Ohme%*%z*qchisq(0.95,3)))
  C_up[i] <- f(a,b,c,t[i])+sqrt(1/n*(t(z)%*%Ohme%*%z*qchisq(0.95,3)))
  zmean[i] <- f(a,b,c,t[i])
  }

# DBH
a <- fixef(DBHnlme)[1];   b <- fixef(DBHnlme)[2];   c <- fixef(DBHnlme)[3]
sum <- matrix(0,3,3)
for(i in 1:n)
 {x <- F$Age[F$ID==ID[i]]
  Z <- matrix(0,length(x),3)
  Z <- cbind(f1(a,b,c,x),f2(a,b,c,x),f3(a,b,c,x))
  Sigma <- diag(DBHsigma2,length(x),length(x))+Z%*%DBHPhi%*%t(Z)
  sum <- sum+t(Z)%*%solve(Sigma)%*%Z
  }
sum <- sum/n
Ohme <- solve(sum)

par(mfrow=c(2,2))                                              # Ot쐻
plot(F[F$ID==ID[1],]$Age, F[F$ID==ID[1],]$DBH, main="f[^", 
     xlim=c(0,30), ylim=c(0,22), type="p", xlab="(N)", 
     ylab="a(cm)")
for(i in 2:length(ID)) 
 {points(F[F$ID==ID[i],]$Age, F[F$ID==ID[i],]$DBH, type="p")}
plot(t, zmean, ylim=c(0,22), xlim=c(0,30), 
     main="ϐƋȐ0.95M", type="l", xlab="(N)", 
     ylab="(m)")
lines(t,C_up,lty=2)
lines(t,C_low,lty=3)
legend("bottomright", c("ϐ","MԂ̏","MԂ̉"),
       lty=c(1,2,3), inset = .05,bty="n")
plot(t, zmean, ylim=c(0,22), xlim=c(0,30), 
     main="_ʂlʐȐ", type="l", xlab="(N)", 
     ylab="a(cm)", lwd=2)
for(i in 1:length(ID))
 {a<-as.numeric(coef(DBHnlme)[i,])
  zind <- f(a[1],a[2],a[3],t)
  lines(t,zind,lty=2)
  }
legend("bottomright", c("ϐ","ʐ萬"), lty=c(1,2), 
       inset = .05, bty="n")



# XNvgUDR --------------------------------------------------------
library(lattice)                                 # Fitting indivisual trees
fit <- data.frame(F$ID,F$Age)
colnames(fit) <- list("ID","Age")

pfit <- predict(DBHnlme, fit, level=0:1)                      # DBH fitting
nF <- cbind(F$ID, F$Age, F$DBH, pfit$predict.fixed, pfit$predict.ID)
nF <- data.frame(nF)
colnames(nF) <- list("ID", "Age", "DBH", "predict.fixed", "predict.ID")
xyplot(DBH+predict.ID+predict.fixed~Age|factor(ID), data=nF, 
       panel=panel.superpose, distribute.type=TRUE, ylab='a(cm)', 
       xlab='(N)', lwd=c(2,2,2), type=c('p','l','l'), pch=c(1, NA,NA), 
       lty=c(1,1,2))



# XNvgVDP --------------------------------------------------------
source("Kankyo.R")
require(nlme)
F <- read.csv("Hoshino_Growth.csv")
colnames(F) <- c("ID", "Age", "DBH", "Height", "Vol")
ID <- HoshinoID
for(i in 1:length(ID)) 
 {F$CDBH[F$ID==ID[i]]<-max(F$DBH[F$ID==ID[i]])}        # ϗʃf[^̉M

x <- F$Age; y <- F$Vol
RSS.6.f <- function(b)
 {temp <- y-GC.expCR.func(b[1], b[2], b[3], x);   t(temp)%*%temp}
opt <- optim(c(0,0,0), RSS.6.f, control=list(maxit=10000))
beta.6 <- opt$par
# mixed effect model with Richards' growth curve
Volnlme <- nlme(Vol ~ GC.expCR.func(a,b,c,Age), data=F, 
                fixed = a+b+c ~ CDBH, random = a+b+c ~ 1, groups = ~ID,
                start=c(a=beta.6[1],a1=0,b=beta.6[2],b1=0,c=beta.6[3],
                        c1=0),
                control=list(maxIter=1000))



# XNvgVDQ --------------------------------------------------------
library(lattice)                                 # Fitting indivisual trees
fit <- data.frame(F$ID,F$Age,F$CDBH)
colnames(fit) <- list("ID","Age","CDBH")

pfit <- predict(Volnlme,fit,level=0:1)                     # Volume fitting
nF <- cbind(F$ID, F$Age, F$CDBH, F$Vol, pfit$predict.fixed, pfit$predict.ID)
nF <- data.frame(nF)
colnames(nF) <- list("ID","Age","CDBH","Vol","predict.fixed","predict.ID")

# Growth Curve I
xyplot(Vol+predict.fixed~Age|factor(ID), data=nF,panel=panel.superpose,
       distribute.type=TRUE, ylab="ސ(m3)", xlab="(N)", 
       lwd=c(2,2), type=c("p","l"), pch=c(1, NA))

# Growth Curve II
xyplot(Vol+predict.ID+predict.fixed~Age|factor(ID),data=nF,
       panel=panel.superpose, distribute.type=TRUE, ylab='ސ(m3)', 
       xlab='(N)', lwd=c(2,2,2), type=c('p','l','l'), pch=c(1, NA,NA),
       lty=c(1,1,2))



# XNvgVDR --------------------------------------------------------
# Growth Prediction for residual trees with DBH
Resd <- read.csv("residual.csv")
age1 <- c(1:50);   i1 <- rep(1,length(Resd$ID))
age2 <- kronecker(i1,age1);   i2 <- rep(1,length(age1))
Resd1 <- kronecker(as.matrix(Resd),i2)
Resd2 <- cbind(Resd1,age2);   Resd2 <- data.frame(Resd2)
colnames(Resd2) <- list("ID", "CDBH", "Age")
fit <- data.frame(Resd2$ID, Resd2$Age, Resd2$CDBH)
colnames(fit) <- list("ID", "Age", "CDBH")
a <- matrix(fixef(Volnlme), byrow=TRUE, ncol=1)
Vol1 <- 1-exp(-exp(a[3]+a[4]*Resd2$CDBH)*Resd2$Age)
Vol1 <- exp(a[1]+a[2]*Resd2$CDBH)*Vol1^(exp(a[5]+a[6]*Resd2$CDBH))
Resd3 <- cbind(Resd2, Vol1)
plot(Resd3$Age[Resd3$ID==1], Resd3$Vol1[Resd3$ID==1], type="l", 
     xlim=c(0,50), ylim=c(0,1), xlab="(N)", ylab="ސ(m3)")
for(i in 1:length(Resd$ID))
  {lines(Resd3$Age[Resd3$ID==i],Resd3$Vol1[Resd3$ID==i])}
boxplot(Vol1~Age, data=Resd3, xlab="(N)", ylab="ސ(m3)")



# XNvgWDP --------------------------------------------------------
source("Kankyo.R")
F <- read.csv("Hoshino_Growth.csv")
names(F) <- c("ID", "Age", "DBH", "Height", "Z")
ID <- HoshinoID
plot(F$Age, F$Height, ylim=c(0,max(F$Height)), type="p", xlab=" (N)", 
     ylab=" (m)")
for(i in 2:length(ID)){points(F$Age, F$Height, type="p")}
tp0 <- c(24.95,0.064,1.97)
res0 <- nls(Height ~ a*(1-exp(-b*Age))^c, F, 
            start=list(a=tp0[1],b=tp0[2],c=tp0[3]))
tp <- coef(res0)
lines(sort(unique(F$Age)), 
      tp[1]*(1-exp(-tp[2]*sort(unique(F$Age))))^tp[3], lty=2, lwd=3)



# XNvgWDQ --------------------------------------------------------
x <- F$Age[F$ID==7];   y <- F$Height[F$ID==7]            # ID=7Ɋւ鐄
da <- data.frame(x,y)
res <- nls(y ~ a*(1-exp(-b*x))^c, da, start=list(a=tp[1],b=tp[2],c=tp[3]))
es <- coef(res); t <- 0:50
plot(t, es[1]*(1-exp(-es[2]*t))^es[3],type="l", ylim=c(0,30), lwd=3,
     xlab=" (N)", ylab=" (m)")
lines(t, tp[1]*(1-exp(-tp[2]*t))^tp[3], lty=2, lwd=3)
lines(x, y, type="p", lwd=8)
legend("topleft", c("Estimation for Individual","Estimation for Total"),
       lty=c(1,2))



# XNvgWDR --------------------------------------------------------
par(mfrow=c(1,2))                                          # 4 data fitting
x1 <- c(5,10,15,20);   y1<-c( 3.580952, 8.441501, 11.530822, 14.948549)
da1 <- data.frame(x1,y1)
res1 <- nls(y1 ~ a*(1-exp(-b*x1))^c, da1, 
            start=list(a=tp[1],b=tp[2],c=tp[3]))
es1 <- coef(res1);   t <- 0:50
plot(t, es1[1]*(1-exp(-es1[2]*t))^es1[3], type="l", ylim=c(0,30), lwd=3,
     xlab=" (N)", ylab=" (m)")
lines(t, es[1]*(1-exp(-es[2]*t))^es[3], lty=2, lwd=3)
lines(t, tp[1]*(1-exp(-tp[2]*t))^tp[3], lty=3, lwd=3)
lines(x1, y1, type="p", lwd=8)
legend("topleft",
       c("Estimation for Ind. with less data","Estimation for Individual",
         "Estimation for Total"),
       lty=c(1,2,3), cex=1, bty="n")

x1 <- c(6, 7, 8, 17, 19)                                    #5 data fitting
y1 <- c(4.622652, 5.534430, 6.608602, 12.764346, 14.347002)
da1 <- data.frame(x1, y1)
res1 <- nls(y1 ~ a*(1-exp(-b*x1))^c, da1, 
            start=list(a=tp[1],b=tp[2],c=tp[3]))
es1 <- coef(res1);   t <- 0:50
plot(t, es1[1]*(1-exp(-es1[2]*t))^es1[3], type="l", ylim=c(0,30), lwd=3,
     xlab=" (N)", ylab=" (m)")
lines(t, es[1]*(1-exp(-es[2]*t))^es[3], lty=2, lwd=3)
lines(t, tp[1]*(1-exp(-tp[2]*t))^tp[3], lty=3, lwd=3)
lines(x1, y1, type="p", lwd=8)
legend("topleft", 
       c("Estimation for Ind. with less data","Estimation for Individual",
         "Estimation for Total"),
       lty=c(1,2,3), bty="n")



# XNvgWDS --------------------------------------------------------
source("Kankyo.R")
F <- read.csv("Hoshino_Growth.csv")
names(F) <- c("ID", "Age", "DBH", "Height", "Z") 
ID <- HoshinoID
tp <- c(23.89,0.064,1.8)             # true values of parameters for height
m <- c(5,10,15,20)                   # years used to make curve
es <- matrix(0,length(ID),3);   xv <- NULL
j <- 1
x <- F$Age[F$ID==ID[j]];   y <- F$Height[F$ID==ID[j]]
da <- data.frame(m,y[4])
RSS.6.f <- function(b) 
 {temp <- y-GC.expCR.func(b[1], b[2], b[3], x);   t(temp)%*%temp}
opt <- optim(c(log(tp[1]),log(tp[2]),log(tp[3])), RSS.6.f, 
             control=list(maxit=10000))
beta.6 <- opt$par
y.hat <- c(1:length(x))
y.hat[1:length(x)] <- GC.expCR.func(beta.6[1], beta.6[2], beta.6[3], x)
conv <- opt$convergence
if(conv != 0) stop
es[j,] <- exp(beta.6)
err <- y-y.hat
xv <- c(xv,err)
xv <- mean(xv^2)
va <- mean((es[,1]-tp[1])^2)
vb <- mean((es[,2]-tp[2])^2)
vc <- mean((es[,3]-tp[3])^2)

xx <- F$Age[F$ID==ID[j]];   yy <- F$Height[F$ID==ID[j]]            # plot
t <- 0:50
# est: MLEs of parameters obtained from restricted measurements
aa <- xx==m[1]
for(ii in 1:length(m)) {aa <- aa | xx==m[ii]}
x <- xx[aa];   y <- yy[aa]              # data for restricted time points
da <- data.frame(x,y)
est <- c(0,0,0)
RSS.6.f <- function(b) 
 {temp <- y-GC.expCR.func(b[1], b[2], b[3], x);   t(temp)%*%temp}
opt <- optim(c(log(es[j,1]),log(es[j,2]),log(es[j,3])), RSS.6.f, 
             control=list(maxit=10000))
beta.6 <- opt$par
y.hat <- c(1:length(x))
y.hat[1:length(x)] <- GC.expCR.func(beta.6[1], beta.6[2], beta.6[3], x)
conv <- opt$convergence
if(conv != 0) stop
est <- exp(beta.6)
# bp: Bayes estimators obtained from restricted measuments
aa <- matrix(c((1-exp(-tp[2]*x))^tp[3],
             tp[1]*tp[2]*tp[3]*(1-exp(-tp[2]*x))^(tp[3]-1)*exp(-tp[2]*x),
             tp[1]*(1-exp(-tp[2]*x))^tp[3]*log(1-exp(-tp[2]*x))),
             length(x), 3)
bp <- solve(t(aa)%*%aa/xv+diag(c(1/va,1/vb,1/vc)))%*%
      (t(aa)%*%(y-tp[1]*(1-exp(-tp[2]*x))^tp[3])/xv)+tp

title <- paste("Tree ID :", ID[j])
plot(x, y, lwd=8, xlim=c(0,50), ylim=c(0,30), xlab="ї (N)",
     ylab=" (m)", type="p", main=title)
lines(t, es[j,1]*(1-exp(-es[j,2]*t))^es[j,3], lwd=3)
lines(t, tp[1]*(1-exp(-tp[2]*t))^tp[3], lty=2, lwd=3, col=4)
lines(t, est[1]*(1-exp(-est[2]*t))^est[3], lty=3, lwd=3, col=3)
lines(t, bp[1]*(1-exp(-bp[2]*t))^bp[3], lty=4, lwd=3, col=2)
legend(25, 12, c("Single Data","All Data","Small Data","Bayes"),
       lwd=3, lty=c(1:4), col=c(1,4,3,2))



# XNvgXDP --------------------------------------------------------
set.seed(1)                                               # ̎̐ݒ
R1 <- rbinom(n=1000, size=10, prob=0.4)                   # 񍀗
R2 <- rpois(n=1000, lambda=3)                             # |A\
R3 <- rmultinom(n=1000, size=10, prob=c(0.2, 0.3, 0.5))   # 



# XNvgXDQ --------------------------------------------------------
summary(R1)     # R1̗v
var(R1)         # U



# XNvgXDR --------------------------------------------------------
plot(0:10, dbinom(0:10,10,0.4), type="h", xlab="ϑ",
     ylab="m")                                                   # }(a)
plot(0:10, table(R1), type="h", xlab="ϑ", ylab="px")         # }(b)



# XNvgXDS --------------------------------------------------------
plot(min(R2):max(R2), dpois(min(R2):max(R2), lambda=3), type="h",
     xlab="ϑ", ylab="m")                                   # Ғl
plot(min(R2):max(R2), table(R2), type="h", xlab="ϑ",
     ylab="px")                                                  # l
table(R2)   # \X.Q



# XNvgXDT --------------------------------------------------------
boxplot(R3[1,], R3[2,], R3[3,], xlab="Cxg", ylab="ϑ", names=c(1,2,3))
points(1:3, c(2, 3, 5), type="l", lty=2)                          # }X.R
table(R3[,1]);   table(R3[,2]);   table(R3[,3])                   # \X.R



# XNvgXDU --------------------------------------------------------
f <- function(t) {1/(1+exp(-t))}                               # N֐
curve(f, xlim=c(-5,5))                                         # Ȑ̕`



# XNvgXDV --------------------------------------------------------
f <- function(t) {1-exp(-exp(t))}                        # ɒlN
curve(f, xlim=c(-4,2))

curve(pnorm, xlim=c(-2,2))                               # vrbgN



# XNvgXDW --------------------------------------------------------
set.seed(1)
n <- 30
x1 <- runif(n, min=0.1, max=0.5)                                 # ϐ
x2 <- runif(n, min=0.5, max=1)
x3 <- runif(n, min=1, max=1.5)
X.full <- cbind(x1, x2, x3)                                    # tf
X.true <- X.full[,1:2]                                         # ^̃f
b.true <- matrix(c(1,2,-2), ncol=1)
p.true <- matrix(0,n,1)
for(i in 1:n) 
 {Xi <- matrix(c(1,X.true[i,]), ncol=1)
  p.true[i] <- exp(t(Xi)%*%b.true)/(1+exp(t(Xi)%*%b.true)) 
  }



# XNvgXDX --------------------------------------------------------
for(iter in 1:1000) 
 {y <- rbinom(n, 20, p.true);   obs <- rbind(obs,y);   y <- cbind(y, 20-y)
  
  res0 <- glm(y~1, family=binomial)                              # fP
  coef0 <- rbind(coef0, res0$coefficients)
  pred0 <- rbind(pred0, exp(predict(res0))/(1+exp(predict(res0))))

  res1 <- glm(y~X.full[,1], family=binomial)                     # fQ
  coef1 <- rbind(coef1, res1$coefficients)
  pred1 <- rbind(pred1, exp(predict(res1))/(1+exp(predict(res1))))
  
  # ȉCf3,4ɂĂl̃R}hpӂ
  # ܂CxXgfɂ\lpred.bestƂėpӂ
  
  AIC <- rbind(AIC, c(res0$aic, res1$aic, res2$aic, res3$aic))
 }

  # FXNvgXDX̖{̃o[W
   coef0 <- coef1 <- coef2 <- coef3 <- pred0 <- pred1 <- pred2 <- pred3 <- NULL
   pred.best <- AIC <- obs <- NULL
   for(iter in 1:1000)
    {y <- rbinom(n, 20, p.true);   obs <- rbind(obs, y);   y <- cbind(y, 20-y)
     
     res0 <- glm(y~1, family=binomial)                              # fP
     coef0 <- rbind(coef0, res0$coefficients)
     pred0 <- rbind(pred0, exp(predict(res0))/(1+exp(predict(res0))))
     
     res1 <- glm(y~X.full[,1], family=binomial)                     # fQ
     coef1 <- rbind(coef1, res1$coefficients)
     pred1 <- rbind(pred1, exp(predict(res1))/(1+exp(predict(res1))))
     
     res2 <- glm(y~X.full[,1:2], family=binomial)                   # fR
     coef2 <- rbind(coef2, res2$coefficients)
     pred2 <- rbind(pred2, exp(predict(res2))/(1+exp(predict(res2))))
     
     res3 <- glm(y~X.full, family=binomial)                         # fS
     coef3 <- rbind(coef3, res3$coefficients)
     pred3 <- rbind(pred3, exp(predict(res3))/(1+exp(predict(res3))))
     
     MinAIC <- min(res0$aic, res1$aic, res2$aic, res3$aic)
     if(res0$aic==MinAIC)
      {pred.best <- rbind(pred.best, exp(predict(res0))/(1+exp(predict(res0))))}
     if(res1$aic==MinAIC)
      {pred.best <- rbind(pred.best, exp(predict(res1))/(1+exp(predict(res1))))}
     if(res2$aic==MinAIC)
      {pred.best <- rbind(pred.best, exp(predict(res2))/(1+exp(predict(res2))))}
     if(res3$aic==MinAIC)
      {pred.best <- rbind(pred.best, exp(predict(res3))/(1+exp(predict(res3))))}
     
     AIC <- rbind(AIC, c(res0$aic, res1$aic, res2$aic, res3$aic))
     }



# XNvgXDPO ------------------------------------------------------
boxplot(coef2[,1], coef2[,2], coef2[,3], main="fR", 
        ylab="mp[^̐")
points(1:3, b.true, type="l", lwd=2, lty=2)



# XNvgXDPP ------------------------------------------------------
plot(0:3, apply(AIC,2,mean), type="o", lwd=5, cex=2, ylab="AIC", 
     xlab="ϐ̌")



# XNvgXDPQ ------------------------------------------------------
model <- NULL
for(i in 1:1000)
 {min.aic <- min(AIC[i,])
  if(AIC[i,1]==min.aic){model <- rbind(model, 0)}
  if(AIC[i,2]==min.aic){model <- rbind(model, 1)}
  if(AIC[i,3]==min.aic){model <- rbind(model, 2)}
  if(AIC[i,4]==min.aic){model <- rbind(model, 3)}
  }
plot(0:3, table(model)/10, xlim=c(-0.5,3.5), ylim=c(0,80), type="h",
     xlab="ϐ̌", ylab="Imij")



# XNvgXDPR ------------------------------------------------------
plot(obs/20, pred0, xlab="m", ylab="\m", main="fP", 
     ylim=c(0,1))



# XNvgXDPS ------------------------------------------------------
SS.mat <- matrix(0,2,2)
for(i in 1:1000)  
for(j in 1:n)
 {if (obs[i,j]/20>=0.5 & pred.best[i,j]>=0.5) {SS.mat[1,1] <- SS.mat[1,1]+1}
  if (obs[i,j]/20>=0.5 & pred.best[i,j]<0.5)  {SS.mat[2,1] <- SS.mat[2,1]+1}
  if (obs[i,j]/20<0.5 & pred.best[i,j]>=0.5)  {SS.mat[1,2] <- SS.mat[1,2]+1}
  if (obs[i,j]/20<0.5 & pred.best[i,j]<0.5)   {SS.mat[2,2] <- SS.mat[2,2]+1}
  }



# XNvgXDPT ------------------------------------------------------
y <- rbinom(n, 20, p.true); y <- cbind(y, 20-y)
res <- glm(y~x1+x2+x3, family=binomial)
step(res)                                                   #XebvCY



# XNvgXDPU ------------------------------------------------------
nishin.char.func <- function(x, n) 
 {tx <- x
  y <- floor(log(x)/log(2))
  r <- ""
  while(y>=0)
   {if(x>=2^y)
     {x <- x-2^y
      r <- paste(r, as.character(1), sep="")
      } else 
     {r <- paste(r, as.character(0), sep="")}
    y <- y-1
    }
  if(nchar(r)<n)
   {for(j in 1:(n-nchar(r))){r <- paste(as.character(0), r, sep="")}}
  if(tx==0){r <- ""}
  return(r)
  }

full.search.logit.func <- function(y, X.full)                    # @̊֐
 {n <- dim(X.full)[1];   p <- dim(X.full)[2];   res.aic <- matrix(0,2^p,p+2)
  for(i in 1:2^p)
   {tempc <- nishin.char.func(i-1,p);   no<-nchar(tempc);
    X <- NULL
    variable <- c(rep(0,p));   var.num <- 0
    for(j in 1:no)
     {if(substr(tempc,j,j)=="1")
       {X <- cbind(X,X.full[,j])
        variable[j] <- 1;   var.num <- var.num+1
        }
      }
    if(i==1){res <- glm(y~1, family=binomial)}
    if(i>1){res <- glm(y~X, family=binomial)}
    res.aic[i,] <- c(var.num, variable ,res$aic)
    }
  res.aic
  }



# XNvgXDPV ------------------------------------------------------
Direc.func <- function(angle)
 {res <- c(0,0,0,0)
  if(angle<=22.5 || angle>337.5){res[1] <- 1}
  if(angle>22.5 && angle<=67.5){res[1] <- 1;   res[2] <- 1}
  if(angle>67.5 && angle<=112.5){res[2] <- 1}
  if(angle>112.5 && angle<=157.5){res[2] <- 1;   res[3] <- 1}
  if(angle>157.5 && angle<=202.5){res[3] <- 1}
  if(angle>202.5 && angle<=247.5){res[3] <- 1;   res[4] <- 1}
  if(angle>247.5 && angle<=292.5){res[4] <- 1}
  if(angle>292.5 && angle<=337.5){res[1] <- 1;   res[4] <- 1}
  res
  }



# XNvgXDPW ------------------------------------------------------
source("Kankyo.R")
F <- read.csv("Toyama_Snow.csv", header=T)
n <- dim(F)[1]
y <- cbind(F$DamageNumber, F$Sample-F$DamageNumber)
N <- sum(y[,1]);   D <- sum(y[,2])



# XNvgXDPX ------------------------------------------------------
dir <- matrix(0, n, 4)
for(i in 1:n){dir[i,] <- Direc.func(F$NorthZero[i])}
X0 <- cbind(F$Age, F$D, F$H, F$H.D, F$Density, F$Sugi, F$Accumulation, 
            F$AboveSea, F$Slope, F$ContributingArea, 
            F$TopographicWetnessIndex, F$Cross, F$Vertical, 
            F$OverGroundOpenness, F$UnderOpenness, dir)



# XNvgXDQO ------------------------------------------------------
Age <- F$Age;   D <- F$D;   H <- F$H;   H.D <- F$H.D;   Density <- F$Density
Sugi <- F$Sugi;   Accum <- F$Accumulation;   AboveSea <- F$AboveSea
Slope <- F$Slope;   CA <- F$ContributingArea
TWI <- F$TopographicWetnessIndex;   Cross <- F$Cross
Vertical <- F$Vertical;   Over <- F$OverGroundOpenness
Under <- F$UnderOpenness;   Dir <- dir

res <- glm(y~Age + D + H + H.D + Density + Sugi + Accum + AboveSea + Slope
             + CA + TWI + Cross + Vertical + Over + Under + Dir,
           family=binomial)
res.step.aic <- step(res)



# XNvgXDQP ------------------------------------------------------
source("Kankyo.R")
res <- full.search.logit(y, X0)



# XNvgXDQQ ------------------------------------------------------
p.temp <- predict(best.res.aic)
p.est <- exp(p.temp)/(1+exp(p.temp))



# XNvg`DP --------------------------------------------------------
F <- read.table("hoshinodata.prn")
names(F) <- c("ID", "DBH", "Height")
hist(F$DBH, xlab="a (cm)", ylab="{", main = "ãqXgO")
hist(F$Height, xlab=" (m)", ylab="{", main = "̃qXgO")



# XNvg`DQ --------------------------------------------------------
P <- read.table("Position.txt")  
names(P) <- c("Type", "ID", "Y", "X", "Z")
plot(P$X[P$Type=="P"], P$Y[P$Type=="P"], type="l", axes=FALSE, xlab="",
     ylab="")
points(P$X[P$Type=="TH"], P$Y[P$Type=="TH"], pch="+", cex=0.7)
text(P$X[P$Type=="TH"]+.5, P$Y[P$Type=="TH"]+.5, cex=0.7,
     labels=P$ID[P$Type=="TH"])
points(P$X[P$Type=="RS"], P$Y[P$Type=="RS"], pch=21)
text(P$X[P$Type=="RS"]+.5, P$Y[P$Type=="RS"]+.5, cex=0.7,
     labels=P$ID[P$Type=="RS"])
for(j in 1:length(P$X))
for(i in 1:30) 
 {if(P$Type[j]=="TH" & P$ID[j]==HoshinoID[i]){points(P$X[j],P$Y[j],pch=19)}}



# XNvg`DR --------------------------------------------------------
Stem <- read.table("stem.prn")  
names(Stem) <- c("ID", "Yr", "X", "Y")
plot(Stem$Y[Stem$ID==7 & Stem$Yr==22], Stem$X[Stem$ID==7 & Stem$Yr==22],
     type="l", xlim=c(0,40), xlab="a (cm)", ylab=" (m)")
for(i in 1:21) 
 {lines(Stem$Y[Stem$ID==7 & Stem$Yr==i], Stem$X[Stem$ID==7 & Stem$Yr==i],
        type="l")
  }



# XNvg`DS --------------------------------------------------------
# Plotting DBH Growth Data
source("Kankyo.R")
F <- read.csv("Hoshino_Growth.csv")
names(F) <- c("ID", "Age", "DBH", "Height", "Z")
plot(F[F$ID==HoshinoID[1],]$Age, F[F$ID==HoshinoID[1],]$DBH, 
     ylim=c(0,max(F$DBH)), type="b", xlab=" (N)", ylab="a (cm)")
for(i in 2:length(HoshinoID)) 
 {points(F[F$ID==HoshinoID[i],]$Age, F[F$ID==HoshinoID[i],]$DBH, type="b")}



# XNvg`DT --------------------------------------------------------
# Plotting Height Growth Data
plot(F[F$ID==HoshinoID[1],]$Age, F[F$ID==HoshinoID[1],]$Height,
     ylim=c(0,max(F$Height)), type="b", xlab=" (N)", ylab=" (m)")
for(i in 2:length(HoshinoID)) 
 {points(F[F$ID==HoshinoID[i],]$Age, F[F$ID==HoshinoID[i],]$Height,
         type="b")
  }



# XNvg`DU --------------------------------------------------------
# Plotting Volume Growth Data
plot(F[F$ID==HoshinoID[1],]$Age, F[F$ID==HoshinoID[1],]$Z, 
     ylim=c(0,max(F$Z)), type="b", xlab=" (N)", 
     ylab=bquote('ސ (m'^'3'*')'))
for(i in 2:length(HoshinoID)) 
 {points(F[F$ID==HoshinoID[i],]$Age, F[F$ID==HoshinoID[i],]$Z, type="b")}


